'use strict'
var appVersion = "0.0.1";

var gymstarapp = angular.module('GymStarApp', [
        'ionic',
        'ngCordova',
        'ngCookies',
        'ngStorage',
        'ionic.service.core',
        //'btford.socket-io',
        //'ionic.service.push',
        //'ngSails',
        'ngResource',
        'angular.filter',
        'angularMoment',
        'GymStarApp.controllers',
        'controllers.exercisesSelect',
        'controllers.weightExercise',
        'controllers.timeExercise',
        'controllers.distanceExercise',
        'controllers.otherExercise',
        'controllers.workoutPost',
        'controllers.exercisecategory',
        'controllers.shareworkoutPost',
        'controllers.social',
        'controllers.team',
        'controllers.setting',
        'controllers.search',
        'controllers.livefeed',
        'controllers.profile',
        'filters.timeFilter',
        'services.common.constants',
        'services.common.image',
        'services.common.resource'
    ])
    .run(function($ionicPlatform, $state, $ionicLoading, $localStorage, $cordovaDialogs, $ionicNavBarDelegate, $cordovaProgress, $rootScope) {
        $ionicPlatform.ready(function() {
            if (window.cordova) {
                if (window.cordova.plugins.Keyboard) {
                    //cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                    cordova.plugins.Keyboard.disableScroll(true); // avoid overscroll of the nav bar
                }

                //app version
                cordova.getAppVersion(function(version) {
                    appVersion = version;
                });

            }
            if (window.StatusBar) {
                StatusBar.styleDefault();
            }

            $rootScope.$on('$cordovaNetwork:offline', function(event, networkState) {
                $cordovaDialogs.alert('Network Offline', 'Alert', 'OK');
            });
            /*
            if (ionic.Platform.isAndroid) {
                var ws = new WebSocket('ws://heroku-postgres-b143a4e2.herokuapp.com/socket.io/1/websocket');
                ws.onopen = function() {
                    console.log('open');
                    this.send('hello'); // transmit "hello" after connecting
                };

                ws.onmessage = function(event) {
                    console.log(event.data); // will be "hello"
                    this.close();
                };

                ws.onerror = function(event) {
                    console.log(event);
                    console.log('error occurred!');
                };

                ws.onclose = function(event) {
                    console.log('close code=' + event.code);
                };
            }*/
            /*
            $rootScope.$on('$cordovaNetwork:online', function(event, networkState) {
                $cordovaDialogs.alert('Network Online', 'Alert', 'OK');
            });*/


            /*
            $scope.$on('$cordovaPush:notificationReceived', function(event, notification) {
                    console.log(JSON.stringify([notification]));
                    if (ionic.Platform.isAndroid()) {
                        //handleAndroid(notification);
                    } else if (ionic.Platform.isIOS()) {
                        //handleIOS(notification);
                        $scope.$apply(function() {
                            $scope.notifications.push(JSON.stringify(notification.alert));
                        })
                    }
                });*/
            /*
            $rootScope.$on('$cordovaPush:tokenReceived', function(event, data) {
                      console.log('Got token', data.token, data.platform);
                      // Do something with the token
                    });*/
        });


        io.socket.on('connecting', function() {
            $rootScope.connStatus = "(Connecting)";
            console.log('Connecting');
        });

         io.socket.on('error', function() {
            console.log('error');
        });

        io.socket.on('connect', function() {
            $rootScope.connStatus = "";
            if ($localStorage.loginuser) {
                io.socket.get('/user/notification/' + $localStorage.loginuser.name);
            }
            if ($localStorage.teams && $localStorage.teams.length != 0) {
                angular.forEach($localStorage.teams, function(team) {
                    io.socket.get('/chat/room/' + team.gid);
                    if (!$localStorage.team_message['team' + team.gid]) $localStorage.team_message['team' + team.gid] = [];
                });
            }
        });

        io.socket.on('disconnect', function() {
            $rootScope.connStatus = "(Disconnect)";
        });

        io.socket.on('message', function(obj) {
            //console.log(obj);
            var _team = obj.team;
            if (obj.messageType == "workout") {
                var _temp = obj.message;
                if (typeof _temp != "object") {
                    _temp = JSON.parse(obj.message);
                }
                obj.message = _temp;
            }
            //if (!$localStorage.team_message['team' + _team]) $localStorage.team_message['team' + _team] = [];
            $localStorage.team_message['team' + _team].push(obj);
            if (!$rootScope.team_message_total) $rootScope.team_message_total = 0;
            if (obj.uid !== $localStorage.loginuser.uid) $rootScope.team_message_total++;
            $rootScope.$apply();
            $rootScope.$broadcast('$gymstar:local_message', obj);
        });

        //new notication
        io.socket.on('notification', function(obj) {
            if (!$localStorage.notifications) $localStorage.notifications = [];
            $localStorage.notifications.push(obj);
            $rootScope.notificationCount++;
            $rootScope.$apply();
            $rootScope.$broadcast('$gymstar:local_notification', obj);
        });

        //new team no mater create one or accept one;

        $rootScope.$on('$gymstar:newTeams', function(event, teams) {
            angular.forEach(teams, function(team) {
                io.socket.get('/chat/room/' + team.gid);
            });
        });

        $rootScope.$on('$gymstar:newTeam', function(event, id) {
            io.socket.get('/chat/room/' + id);
        });

        //leave team 
        $rootScope.$on('$gymstar:leaveTeams', function(event, teams) {
            angular.forEach(teams, function(team) {
                io.socket.post('/chat/room', {
                    team: team.gid
                });
            });
        });

        $rootScope.$on('$gymstar:leaveTeam', function(event, gid) {
            io.socket.post('/chat/room', {
                team: gid
            });
        });


        $rootScope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams) {
            if (toState.name == "searchtabs.search_users" && fromState.name != "visitorprofile" && fromState.name != "following" && fromState.name != "followers") {
                delete $localStorage.usersearch;
                delete $localStorage.workoutsearch;
            }
        });

        $rootScope.$on("$stateChangeSuccess", function(event, toState, toParams, fromState, fromParams) {
            /*if (toState.name == "tabs.livefeed") {
                $ionicLoading.hide();
            }*/
        });

        $ionicPlatform.on("pause", function(event) {
            io.socket.disconnect();
        });


        $ionicPlatform.on("resume", function(event) {
            // user opened the app from the background
            if ($localStorage.loginuser) {
                io.socket.get('/user/notification/' + $localStorage.loginuser.name);
            }
            if ($localStorage.teams && $localStorage.teams.length != 0) {
                angular.forEach($localStorage.teams, function(team) {
                    io.socket.get('/chat/room/' + team.gid);
                    if (!$localStorage.team_message['team' + team.gid]) $localStorage.team_message['team' + team.gid] = [];
                });
            }
        });
    })
    /*
    .factory('mySocket', function(socketFactory) {
        return socketFactory();
    })
    
    .config(['$ionicAppProvider', function($ionicAppProvider) {
        // Identify app
        $ionicAppProvider.identify({
            // The App ID for the server
            app_id: 'e798f05e',
            // The API key all services will use for this app
            api_key: 'AIzaSyBYV55wlhaqqhoVuKCKy1t2vNcgaXlct2k',
            dev_push: true,
            gcm_id: '678691911711'
        });
    }])*/
    .config(function($stateProvider, $urlRouterProvider) {
        $stateProvider
            .state('welcome', {
                url: '/welcome',
                authenticate: false,
                templateUrl: 'templates/welcome.html',
                controller: 'WelcomeCtrl'
            })
            .state('signin', {
                url: '/signin',
                authenticate: false,
                templateUrl: 'templates/signin.html'
            })
            .state('signup', {
                url: '/signup',
                authenticate: false,
                templateUrl: 'templates/signup.html',
                controller: 'SignUpCtrl'
            })
            .state('personaldetails', {
                url: '/personaldetails',
                authenticate: false,
                templateUrl: 'templates/personaldetails.html'
            })
            .state('currentstats', {
                url: '/currentstats',
                templateUrl: 'templates/currentstats/currentstats.html',
                controller: 'SignUpFormCtrl',
                authenticate: false
            })
            .state('currentstats.units', {
                url: '/units',
                templateUrl: 'templates/currentstats/units.html',
                authenticate: false
            })
            .state('currentstats.weight', {
                url: '/weight',
                authenticate: false,
                templateUrl: 'templates/currentstats/weight.html'
            })
            .state('currentstats.height', {
                url: '/height',
                authenticate: false,
                templateUrl: 'templates/currentstats/height.html'
            })
            .state('currentstats.bodyfat', {
                url: '/bodyfat',
                authenticate: false,
                templateUrl: 'templates/currentstats/bodyfat.html'
            })
            .state('currentstats.restbpm', {
                url: '/restbpm',
                authenticate: false,
                templateUrl: 'templates/currentstats/restbpm.html'
            })
            .state('currentstats.pb', {
                url: '/pb',
                authenticate: false,
                templateUrl: 'templates/currentstats/pb.html'
            })
            .state('otherprofile', {
                url: '/other/:target/profile',
                authenticate: true,
                templateUrl: 'templates/otherprofile.html',
                controller: 'VistorProfileCtrl'
            })
            .state('visitorprofile', {
                url: '/user/:target/profile',
                authenticate: true,
                templateUrl: 'templates/visitorprofile.html',
                controller: 'VistorProfileCtrl'
            })
            .state('followers', {
                url: '/user/:uid/followers',
                authenticate: true,
                templateUrl: 'templates/followers.html',
                controller: 'FollowersCtrl'
            })
            .state('following', {
                url: '/user/:uid/following',
                authenticate: true,
                templateUrl: 'templates/following.html',
                controller: 'FollowingCtrl'
            })
            .state('myfollowers', {
                url: '/myfollowers',
                authenticate: true,
                templateUrl: 'templates/myfollowers.html',
                controller: 'MyFollowersCtrl'
            })
            .state('myfollowing', {
                url: '/myfollowing',
                authenticate: true,
                templateUrl: 'templates/myfollowing.html',
                controller: 'MyFollowingCtrl'
            })
            .state('exercisecategories', {
                url: '/exercisecategories',
                authenticate: true,
                templateUrl: 'templates/exercisecategories.html',
                controller: 'ExercisesSelectCtrl'
            })
            .state('exercises_shoulders', {
                url: '/exercises_shoulders',
                authenticate: true,
                templateUrl: 'templates/exercises/shoulders.html',
                controller: 'ExercisesSelectCtrl'
            })
            .state('exercises_triceps', {
                url: '/exercises_triceps',
                authenticate: true,
                templateUrl: 'templates/exercises/triceps.html',
                controller: 'ExercisesSelectCtrl'
            })
            .state('exercises_biceps', {
                url: '/exercises_biceps',
                authenticate: true,
                templateUrl: 'templates/exercises/biceps.html',
                controller: 'ExercisesSelectCtrl'
            })
            .state('exercises_chest', {
                url: '/exercises_chest',
                authenticate: true,
                templateUrl: 'templates/exercises/chest.html',
                controller: 'ExercisesSelectCtrl'
            })
            .state('exercises_back', {
                url: '/exercises_back',
                authenticate: true,
                templateUrl: 'templates/exercises/back.html',
                controller: 'ExercisesSelectCtrl'
            })
            .state('exercises_legs', {
                url: '/exercises_legs',
                authenticate: true,
                templateUrl: 'templates/exercises/legs.html',
                controller: 'ExercisesSelectCtrl'
            })
            .state('exercises_core', {
                url: '/exercises_core',
                authenticate: true,
                templateUrl: 'templates/exercises/core.html',
                controller: 'ExercisesSelectCtrl'
            })
            .state('exercises_cardio', {
                url: '/exercises_cardio',
                authenticate: true,
                templateUrl: 'templates/exercises/cardio.html',
                controller: 'ExercisesSelectCtrl'
            })
            .state('settings', {
                url: '/settings',
                authenticate: true,
                templateUrl: 'templates/settings.html',
            })
            .state('settings_help', {
                url: '/settings/help',
                authenticate: true,
                templateUrl: 'templates/settings/help.html',
                controller: 'SettingsHelpCtrl'
            })
            .state('settings_profile', {
                url: '/settings/profile',
                authenticate: true,
                templateUrl: 'templates/settings/profile.html',
                controller: 'SettingsProfileCtrl'
            })
            .state('settings_profile_picture', {
                url: '/settings/profile/picture',
                authenticate: true,
                templateUrl: 'templates/settings/profile/picture.html',
                controller: 'SettingsProfileCtrl'
            })
            .state('settings_profile_info', {
                url: '/settings/profile/information',
                authenticate: true,
                templateUrl: 'templates/settings/profile/information.html',
                controller: 'SettingsProfileCtrl'
            })
            .state('settings_chat', {
                url: '/settings/chat',
                authenticate: true,
                templateUrl: 'templates/settings/chat.html',
                controller: 'SettingsChatCtrl'
            })
            .state('settings_account', {
                url: '/settings/account',
                authenticate: true,
                templateUrl: 'templates/settings/account.html',
                controller: 'SettingsAccountCtrl'
            })
            .state('settings_privacy', {
                url: '/settings/account/privacy',
                authenticate: true,
                templateUrl: 'templates/settings/account/privacy.html',
                controller: 'SettingsAccountCtrl'
            })
            .state('settings_blockedusers', {
                url: '/settings/account/blockedusers',
                authenticate: true,
                templateUrl: 'templates/settings/account/blockedusers.html',
                controller: 'SettingsBlockUserCtrl'
            })
            .state('settings_password', {
                url: '/settings/account/password',
                authenticate: true,
                templateUrl: 'templates/settings/account/password.html',
                controller: 'SettingsAccountCtrl'
            })
            .state('settings_unit', {
                url: '/settings/account/unit',
                authenticate: true,
                templateUrl: 'templates/settings/account/unit.html',
                controller: 'SettingsAccountCtrl'
            })
            .state('settings_notifications', {
                url: '/settings/notifications',
                authenticate: true,
                templateUrl: 'templates/settings/notifications.html'
            })
            .state('settings_contacts', {
                url: '/settings/contacts',
                authenticate: true,
                templateUrl: 'templates/settings/contacts.html'
            })
            .state('donations', {
                url: '/donations',
                authenticate: true,
                templateUrl: 'templates/donations.html',
                controller: 'DonationCtrl'
            })
            .state('workout', {
                url: '/workout/:id',
                authenticate: true,
                templateUrl: 'templates/workout.html',
                controller: 'WorkoutCtrl'
            })
            .state('favourites', {
                url: '/favourites',
                authenticate: true,
                templateUrl: 'templates/favourites.html',
                controller: 'FavouriteCtrl'
            })
            .state('formteam1', {
                url: '/formteam1',
                authenticate: true,
                templateUrl: 'templates/formteam1.html',
                controller: 'FormTeamCtrl'
            })
            .state('formteam2', {
                url: '/formteam2',
                authenticate: true,
                templateUrl: 'templates/formteam2.html',
                controller: 'FormTeamInviteCtrl'
            })
            .state('selectexercise', {
                url: '/selectexercise',
                authenticate: true,
                templateUrl: 'templates/selectexercise.html'
            })
            .state('exercises', {
                url: '/exercises',
                authenticate: true,
                templateUrl: 'templates/exercises.html',
            })
            .state('exercise_weight_reps', {
                url: '/exercise_weightreps/:exerciseName/:indexId',
                authenticate: true,
                templateUrl: 'templates/exercise/weightreps.html',
            })
            .state('exercise_distance_time', {
                url: '/exercise_distancetime/:exerciseName/:indexId',
                authenticate: true,
                templateUrl: 'templates/exercise/distancetime.html',
            })
            .state('exercise_time', {
                url: '/exercise_time/:exerciseName/:indexId',
                authenticate: true,
                templateUrl: 'templates/exercise/time.html',
            })
            .state('exercise_other', {
                url: '/exercise_other/:exerciseName/:indexId',
                authenticate: true,
                templateUrl: 'templates/exercise/other.html',
            })
            .state('shareworkout', {
                url: '/shareworkout',
                authenticate: true,
                templateUrl: 'templates/shareworkout.html',
                controller: 'ShareWorkoutCtrl'
            })
            .state('notifications', {
                url: '/notifications',
                authenticate: true,
                templateUrl: 'templates/notifications.html'
            })
            .state('searchtabs', {
                url: "/searchtab",
                abstract: true,
                authenticate: true,
                templateUrl: "templates/searchtabs.html"
            })
            .state('searchtabs.search_users', {
                url: "/search_users",
                authenticate: true,
                views: {
                    'search_users-tab': {
                        templateUrl: "templates/search_users.html",
                        controller: 'SearchUserCtrl'
                    }
                }
            })
            .state('searchtabs.search_workouts', {
                url: "/search_workouts",
                authenticate: true,
                views: {
                    'search_workouts-tab': {
                        templateUrl: "templates/search_workouts.html",
                        controller: 'SearchWorkoutCtrl'
                    }
                }
            })
            .state('tabs', {
                url: "/tab",
                authenticate: true,
                abstract: true,
                templateUrl: "templates/tabs.html"
            })
            .state('tabs.livefeed', {
                url: "/livefeed",
                authenticate: true,
                views: {
                    'livefeed-tab': {
                        templateUrl: "templates/livefeed.html",
                        controller: 'LiveFeedCtrl'
                    }
                }
            })
            .state('tabs.postworkout', {
                url: "/postworkout",
                authenticate: true,
                views: {
                    'postworkout-tab': {
                        templateUrl: "templates/postworkout.html",
                        controller: "PostWorkoutCtrl"
                    }
                }
            })
            .state('tabs.myprofile', {
                url: "/myprofile",
                authenticate: true,
                views: {
                    'myprofile-tab': {
                        templateUrl: "templates/myprofile.html",
                        controller: 'ProfileCtrl'
                    }
                }
            })
            .state('tabs.teams', {
                url: "/teams",
                authenticate: true,
                views: {
                    'teams-tab': {
                        templateUrl: "templates/teams.html",
                        //controller: 'TeamCtrl'
                    }
                }
            })
            .state('gallery', {
                url: '/gallery/:uid',
                authenticate: true,
                templateUrl: 'templates/gallery.html',
                controller: 'GalleryCtrl'
            })
            .state('gallery_image', {
                url: '/gallery_image',
                authenticate: true,
                templateUrl: 'templates/gallery_image.html'
            })
            .state('personalbests', {
                url: '/personalbests',
                authenticate: true,
                templateUrl: 'templates/personalbests.html',
                controller: 'PBCtrl'
            })

        .state('team_template', {
                url: '/team_template/:teamId/:teamName',
                templateUrl: 'templates/team_template.html',
                authenticate: true
            })
            .state('teamconfig', {
                url: '/teamconfig/:teamId',
                authenticate: true,
                templateUrl: 'templates/team_config.html',
                controller: 'TeamConfigCtrl'
            });
        $urlRouterProvider.otherwise("/welcome");
    });

gymstarapp.service('UserDataService', function($rootScope, Constants, $filter, $http, ErrorHandler, workoutService) {
    var serviceUrl = Constants.API.serviceUrl;
    var CONSTANT_TIMEOUT = Constants.timeout;
    var user = {};
    this.displayUser = function(user) {
        var IMG_PATH = Constants.API.IMG_PATH;
        var Profile_Thumbnail = Constants.API.Profile_Thumbnail;
        var displayUser = {};
        displayUser.uid = user.uid;
        displayUser.name = user.name;
        //displayUser.mail=user.mail;
        displayUser.follow = user.follow;
        displayUser.access = user.access;
        displayUser.follower = user.followers;
        displayUser.following = user.followings;
        displayUser.personalbests = user.personal_bests;
        displayUser.firstname = user.field_name_first["und"]["0"]["value"];
        if(user.field_name_last["und"]) displayUser.lastname = user.field_name_last["und"]["0"]["value"];
        else displayUser.lastname="";
        if (user.field_chat_clear_date && user.field_chat_clear_date.length != 0) displayUser.clearChatDate = user.field_chat_clear_date["und"]["0"]["value"];
        //displayUser.privacy = user.field_privacy["und"]["0"]["value"];
        if(user.privacy) {
            displayUser.privacy = parseInt(user.privacy);
            $rootScope.loginUserPrivacy = displayUser.privacy;
        }
        if (user.field_profile && user.field_profile["und"]) {
            //displayUser.fullPicturePath = IMG_PATH + user.field_profile["und"]["0"]["filename"];
            displayUser.picturePath = IMG_PATH + user.field_profile["und"]["0"]["filename"];
        } else {
            displayUser.picturePath = "img/noprofile2_pic.png";
            //displayUser.fullPicturePath = "img/noprofile2_pic.png";
        }
        if (user.field_bio["und"]) displayUser.bio = user.field_bio["und"]["0"]["value"];
        else displayUser.bio = "";
        displayUser.towncity = user.field_city_town["und"]["0"]["value"];
        displayUser.country = user.field_country["und"]["0"]["value"];
        //calculate age
        var _dob = user.field_dob["und"]["0"]["value"];
        //displayUser.dob = _dob;
        var today = new Date();
        var birthDate = new Date(_dob.replace(/-/g, '/'));

        displayUser.dob = birthDate;
        var age = today.getFullYear() - birthDate.getFullYear();
        var m = today.getMonth() - birthDate.getMonth();
        if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
            age--;
        }
        displayUser.age = age;
        displayUser.gender = user.field_gender["und"]["0"]["value"];
        displayUser.weightUnit = user.field_weight_unit["und"]["0"]["value"];
        displayUser.heightUnit = user.field_height_unit["und"]["0"]["value"];
        if (user.field_distance_unit["und"]["0"]["value"] == "m/km") displayUser.distanceUnit = "km";
        else displayUser.distanceUnit = user.field_distance_unit["und"]["0"]["value"];

        if (user.field_weight["und"] && user.field_weight["und"]["0"]["value"] != 0) {
            var _weight = parseFloat(user.field_weight["und"]["0"]["value"]);
            if (displayUser.weightUnit == "st") {
                _weight = _weight / 6.35029;
                displayUser.weight = _weight.toFixed(2);
            } else if (displayUser.weightUnit == "lb") {
                _weight = _weight / 0.45359;
                displayUser.weight = _weight.toFixed(2);
            } else {
                displayUser.weight = _weight;
            }
        } else displayUser.weight = "-";
        if (user.field_height["und"] && user.field_height["und"]["0"]["value"] != 0) {
            var _height = parseFloat(user.field_height["und"]["0"]["value"]);
            if (displayUser.heightUnit == "ft") {
                _height = _height / 30.48;
                displayUser.height = _height.toFixed(2);
            } else {
                displayUser.height = _height;
            }
        } else displayUser.height = "-";

        if (user.field_weight["und"] && user.field_weight["und"]["0"]["value"] != 0 && user.field_height["und"] && user.field_height["und"]["0"]["value"] != 0) {
            var _height = user.field_height["und"]["0"]["value"];
            _height = _height / 100;
            var _weight = user.field_weight["und"]["0"]["value"];
            var _bmi = _weight / (_height * _height);
            displayUser.bmi = _bmi.toFixed(1);
        } else displayUser.bmi = "-";
        workoutService.setUnit(displayUser.weightUnit, displayUser.distanceUnit);
        if (user.field_body_fat["und"] && user.field_body_fat["und"]["0"]["value"] != 0) displayUser.bodyfat = user.field_body_fat["und"]["0"]["value"];
        else displayUser.bodyfat = "-";
        if (user.field_restbpm["und"] && user.field_restbpm["und"]["0"]["value"] != 0) displayUser.restbpm = user.field_restbpm["und"]["0"]["value"];
        else displayUser.restbpm = "-";
        if (user.field_deadlift["und"]) displayUser.deadlift = user.field_deadlift["und"]["0"]["value"];
        else displayUser.deadlift = "-";
        if (user.field_bench_press["und"]) displayUser.benchpress = user.field_bench_press["und"]["0"]["value"];
        else displayUser.benchpress = "-";
        if (user.field_squats["und"]) displayUser.squats = user.field_squats["und"]["0"]["value"];
        else displayUser.squats = "-";
        if (user.field_plank["und"]) {
            var _plank = user.field_plank["und"]["0"]["value"];
            var _temp = $filter('timeFilter')(parseInt(_plank));
            displayUser.plank = _temp;
        } else displayUser.plank = "-";
        if (user.field_1_mile_time["und"]) {
            var _1_mile = user.field_1_mile_time["und"]["0"]["value"];
            var _temp = $filter('timeFilter')(parseInt(_1_mile));
            displayUser.onemile = _temp;
        } else displayUser.onemile = "-";

        //console.log(user);
        //hide information
        if (user.field_hide_bmi && user.field_hide_bmi != "" && user.field_hide_bmi["und"]["0"]["value"] == 1) displayUser.hide_bmi = true;
        else displayUser.hide_bmi = false;

        if (user.field_hide_height && user.field_hide_height != "" && user.field_hide_height["und"]["0"]["value"] == 1) displayUser.hide_height = true;
        else displayUser.hide_height = false;

        if (user.field_hide_weight && user.field_hide_weight != "" && user.field_hide_weight["und"]["0"]["value"] == 1) displayUser.hide_weight = true;
        else displayUser.hide_weight = false;

        if (user.field_hide_body_fat && user.field_hide_body_fat != "" && user.field_hide_body_fat["und"]["0"]["value"] == 1) displayUser.hide_body_fat = true;
        else displayUser.hide_body_fat = false;

        if (user.field_hide_bpm && user.field_hide_bpm != "" && user.field_hide_bpm["und"]["0"]["value"] == 1) displayUser.hide_bpm = true;
        else displayUser.hide_bpm = false;

        if (user.field_hide_age && user.field_hide_age != "" && user.field_hide_age["und"]["0"]["value"] == 1) displayUser.hide_age = true;
        else displayUser.hide_age = false;

        if (user.field_hide_location && user.field_hide_location != "" && user.field_hide_location["und"]["0"]["value"] == 1) displayUser.hide_location = true;
        else displayUser.hide_location = false;

        if (user.field_hide_gender && user.field_hide_gender != "" && user.field_hide_gender["und"]["0"]["value"] == 1) displayUser.hide_gender = true;
        else displayUser.hide_gender = false;
        //console.log(displayUser);
        return displayUser;
    }

    this.getTeams = function(_uid) {
        $http.post(serviceUrl + "/user/" + _uid + "/team", {}, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            return response.data;
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    this.setUser = function(newUser) {
        user = newUser;
    }

    this.getUser = function() {
        return user;
    }
});

gymstarapp.service('NotificationService', function($localStorage, $rootScope) {
    var _notifications = [];
    this.send = function(_fusername, _fuid, _tusername, _tuid, _message, _type) {
        io.socket.post('/user/notification/' + _tusername, {
            username_from: _fusername,
            uid_from: _fuid,
            username_to: _tusername,
            uid_to: _tuid,
            messageType: _type,
            message: _message
        });
    }
});

gymstarapp.service('ErrorHandler', function($http, $state, $localStorage, $ionicPopup, $ionicLoading, $cordovaDialogs, $cordovaToast, Constants) {
    var CONSTANT_TIMEOUT = Constants.timeout;
    this.errorHandler = function(err) {
        $ionicLoading.hide();

        if (err.status === 0) {
            $cordovaToast.showShortCenter("Timeout, Please try again!");
        } else if (err.statusText.indexOf('Access denied for user anonymous') > -1) {
            $localStorage.$reset();
            $state.go('signin');
        } else if (err.statusText.indexOf('CSRF') > -1) {
            $http.get(Constants.API.tokenUrl, {
                timeout: CONSTANT_TIMEOUT
            }).then(function(resp) {
                $localStorage.csrftoken = resp.data;
            }, function(err) {
                if (err.status === 0) {
                    $cordovaToast.showShortCenter("Timeout, Please try again!");
                } else $cordovaToast.showShortCenter("Network error, Please try again!");
            });
        } else if (err.status && err.status == 404) {
            if (err.statusText.indexOf('Not found') > -1 && err.statusText.indexOf('Node') > -1) {
                $cordovaToast.showShortCenter('The workout post is deleted!');
                $state.go('tabs.livefeed');
            }
        } else {
            if (err.status && err.status == 406) {
                if (err.statusText.indexOf('Not Acceptable : User is not logged in.') > -1) {
                    $cordovaToast.showShortCenter('user is not logged in!');
                    $state.go('welcome');
                } else if ((err.statusText.indexOf('Not found') > -1 || err.statusText.indexOf('does not exist') > -1) && err.statusText.indexOf('Node') > -1) {
                    $cordovaToast.showShortCenter('The workout post is deleted!');
                    $state.go('tabs.livefeed');
                } else {
                    $cordovaToast.showShortCenter(err.statusText);
                }
            } else {
                $cordovaToast.showShortCenter("Network error, Please try later!");
            }
        }
    }

    this.alertPopup = function(_msg) {
        $cordovaDialogs.alert(_msg, 'Alert', 'OK');
    }

    this.alertPopupTitle = function(errorMsg, title) {
        $cordovaDialogs.alert(errorMsg, title, 'OK');
    }

    this.confirmPopup = function(_msg) {
        return $cordovaDialogs.confirm(_msg, 'Confirm', ['OK', 'Cancel']);
    }
});

gymstarapp.service('NotificationHandler', function($cordovaToast, $cordovaDialogs, $cordovaProgress, $timeout) {
    this.favToast = function(_flag) {
        if (_flag == 0) $cordovaToast.showShortCenter("added to favourites");
        else if (_flag == 1) $cordovaToast.showShortCenter("removed from favourites");
    };
    this.toast = function(_msg) {
        $cordovaToast.showShortCenter(_msg);
    };
    this.prompt = function(_msg, _title, _text) {
        return $cordovaDialogs.prompt(_msg, _title, ['Cancel', 'OK'], _text);
    };
    this.alert = function(_msg) {
        return $cordovaDialogs.alert(_msg, 'Alert', 'OK');
    };
    this.confirm = function(_msg, _title) {
        return $cordovaDialogs.confirm(_msg, _title, ['Cancel', 'OK']);
    };
    this.confirmRepost = function(_msg, _title) {
        return $cordovaDialogs.confirm(_msg, _title, ['Delete', 'Resend']);
    };

    this.success = function(_msg) {
        $cordovaProgress.showSuccess(true, _msg);
        $timeout(function() {
            $cordovaProgress.hide();
        }, 1000);
    }
});

gymstarapp.service('AuthService', function($ionicLoading, $cordovaPush, $cordovaToast, $http, $rootScope, Constants, $ionicHistory, $localStorage, $state, ErrorHandler) {
    var CONSTANT_TIMEOUT = Constants.timeout;
    this.init = function() {
        $localStorage.team_message = {};
        if ($localStorage.loginuser) {
            var loginUser = $localStorage.loginuser;
            io.socket.get('/user/notification/' + loginUser.name);
            $http.get(Constants.API.socketUrl + '/user/notifications/' + loginUser.name, {
                    timeout: CONSTANT_TIMEOUT
                })
                .success(function(success_data) {
                    $localStorage.notifications = success_data;
                    $rootScope.notificationCount = success_data.length;
                }).error(function(response) {
                    if (resposne.status === 0) {
                        $cordovaToast.showShortCenter("Timeout, Please try again!");
                    }
                });

        }
        if ($localStorage.teams && $localStorage.teams.length != 0) {
            var _teams = $localStorage.teams;
            var _uid = $localStorage.loginuser.uid;
            $rootScope.team_message_total = 0;
            angular.forEach(_teams, function(team) {
                io.socket.get('/chat/room/' + team.gid);
                $localStorage.team_message['team' + team.gid] = [];
                var _team_access = $localStorage.loginuser.access * 1000;
                if (_team_access) {
                    $http.get(Constants.API.socketUrl + '/unread/room/' + team.gid + '/' + _uid + '/' + _team_access, {
                            timeout: CONSTANT_TIMEOUT
                        })
                        .success(function(success_data) {
                            if (!success_data) success_data = 0;
                            team.unreadMsg = success_data;
                            $rootScope.team_message_total = $rootScope.team_message_total + success_data;
                        }).error(function(response) {
                            if (resposne.status === 0) {
                                $cordovaToast.showShortCenter("Timeout, Please try again!");
                            }
                        });
                } else {
                    team.unreadMsg = 0;
                }
            }, $localStorage.teams);
        }
    };

    /*
    this.register = function() {
        var config = null;
        if (ionic.Platform.isAndroid()) {
            config = {
                "senderID": "gymstar-975" //627324653721
            };
        } else if (ionic.Platform.isIOS()) {
            config = {
                "badge": "true",
                "sound": "true",
                "alert": "true"
            }
        }
        $cordovaPush.register(config).then(function(result) {
            console.log("Register success " + result);
            // ** NOTE: Android regid result comes back in the pushNotificationReceived, only iOS returned here
            if (ionic.Platform.isIOS()) {
                $localStorage.regId = result;
                storeDeviceToken("ios");
            }
        }, function(err) {
            console.log("Register error " + err)
        });

        function storeDeviceToken(type) {
            // Create a random userid to store with it
            var user = {
                user: $localStorage.loginuser.id,
                type: type,
                token: $localStorage.regId
            };
            console.log("Post token for registered device with data " + JSON.stringify(user));
            $http.post(Constants.socketUrl + '/subscribe', JSON.stringify(user))
                .success(function(data, status) {
                    console.log("Token stored, device is successfully subscribed to receive push notifications.");
                })
                .error(function(data, status) {
                    console.log("Error storing device token." + data + " " + status)
                });
        }
    };

    this.unregister = function() {
        var tkn = {
            "token": $localStorage.regId
        };
        $http.post(Constants.socketUrl + '/unsubscribe', JSON.stringify(tkn))
            .success(function(data, status) {
                console.log("Token removed, device is successfully unsubscribed and will not receive push notifications.");
            })
            .error(function(data, status) {
                console.log("Error removing device token." + data + " " + status)
            });
    };

    this.notificaiton = function() {
        $scope.register();
        // Register
        $scope.register = function() {
            var config = null;
            if (ionic.Platform.isAndroid()) {
                config = {
                    "senderID": "627324653721" //gymstar-975
                };
            } else if (ionic.Platform.isIOS()) {
                config = {
                    "badge": "true",
                    "sound": "true",
                    "alert": "true"
                }
            }

            $cordovaPush.register(config).then(function(result) {
                console.log("Register success " + result);
                // ** NOTE: Android regid result comes back in the pushNotificationReceived, only iOS returned here
                if (ionic.Platform.isIOS()) {
                    $localStorage.regId = result;
                    storeDeviceToken("ios");
                }
            }, function(err) {
                console.log("Register error " + err)
            });
        }

        // Notification Received
        $scope.$on('$cordovaPush:notificationReceived', function(event, notification) {
            console.log(JSON.stringify([notification]));
            if (ionic.Platform.isAndroid()) {
                handleAndroid(notification);
            } else if (ionic.Platform.isIOS()) {
                handleIOS(notification);
                $scope.$apply(function() {
                    $scope.notifications.push(JSON.stringify(notification.alert));
                })
            }
        });

        // Android Notification Received Handler
        function handleAndroid(notification) {
            // ** NOTE: ** You could add code for when app is in foreground or not, or coming from coldstart here too
            //             via the console fields as shown.
            console.log("In foreground " + notification.foreground + " Coldstart " + notification.coldstart);
            if (notification.event == "registered") {
                $scope.regId = notification.regid;
                storeDeviceToken("android");
            } else if (notification.event == "message") {
                $cordovaDialogs.alert(notification.message, "Push Notification Received");
                $scope.$apply(function() {
                    $scope.notifications.push(JSON.stringify(notification.message));
                })
            } else if (notification.event == "error")
                $cordovaDialogs.alert(notification.msg, "Push notification error event");
            else $cordovaDialogs.alert(notification.event, "Push notification handler - Unprocessed Event");
        }

        // IOS Notification Received Handler
        function handleIOS(notification) {
                // The app was already open but we'll still show the alert and sound the tone received this way. If you didn't check
                // for foreground here it would make a sound twice, once when received in background and upon opening it from clicking
                // the notification when this code runs (weird).
                if (notification.foreground == "1") {
                    // Play custom audio if a sound specified.
                    if (notification.sound) {
                        var mediaSrc = $cordovaMedia.newMedia(notification.sound);
                        mediaSrc.promise.then($cordovaMedia.play(mediaSrc.media));
                    }

                    if (notification.body && notification.messageFrom) {
                        $cordovaDialogs.alert(notification.body, notification.messageFrom);
                    } else $cordovaDialogs.alert(notification.alert, "Push Notification Received");

                    if (notification.badge) {
                        $cordovaPush.setBadgeNumber(notification.badge).then(function(result) {
                            console.log("Set badge success " + result)
                        }, function(err) {
                            console.log("Set badge error " + err)
                        });
                    }
                }
                // Otherwise it was received in the background and reopened from the push notification. Badge is automatically cleared
                // in this case. You probably wouldn't be displaying anything at this point, this is here to show that you can process
                // the data in this situation.
                else {
                    if (notification.body && notification.messageFrom) {
                        $cordovaDialogs.alert(notification.body, "(RECEIVED WHEN APP IN BACKGROUND) " + notification.messageFrom);
                    } else $cordovaDialogs.alert(notification.alert, "(RECEIVED WHEN APP IN BACKGROUND) Push Notification Received");
                }
            }
            // Stores the device token in a db using node-pushserver (running locally in this case)
            //
            // type:  Platform type (ios, android etc)
        function storeDeviceToken(type) {
            // Create a random userid to store with it
            var user = {
                user: $localStorage.loginuser.id,
                type: type,
                token: $localStorage.regId
            };

            console.log("Post token for registered device with data " + JSON.stringify(user));
            $http.post(Constants.socketUrl + '/subscribe', JSON.stringify(user))
                .success(function(data, status) {
                    console.log("Token stored, device is successfully subscribed to receive push notifications.");
                })
                .error(function(data, status) {
                    console.log("Error storing device token." + data + " " + status)
                });
        }

        // Removes the device token from the db via node-pushserver API unsubscribe (running locally in this case).
        // If you registered the same device with different userids, *ALL* will be removed. (It's recommended to register each
        // time the app opens which this currently does. However in many cases you will always receive the same device token as
        // previously so multiple userids will be created with the same token unless you add code to check).
        function removeDeviceToken() {
            var tkn = {
                "token": $localStorage.regId
            };
            $http.post(Constants.socketUrl + '/unsubscribe', JSON.stringify(tkn))
                .success(function(data, status) {
                    console.log("Token removed, device is successfully unsubscribed and will not receive push notifications.");
                })
                .error(function(data, status) {
                    console.log("Error removing device token." + data + " " + status)
                });
        }
    };*/

    this.logout = function() {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner> <p>Logout...</p>',
            duration: CONSTANT_TIMEOUT
        });
        $http.post(Constants.API.logoutUrl, {}, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            $localStorage.$reset();
            $ionicLoading.hide();
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true,
                historyRoot: true
            });
            $state.go('welcome');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    };

});

gymstarapp.factory('workoutStyle', function() {
    var rowClass = function(exercise_index, set_index, subset_length) {
        if (set_index == subset_length - 1) return "text-size10 ex-colour" + (exercise_index + 1) + "-" + (set_index % 4 + 1);
        else return "item-borderbottom text-size10 ex-colour" + (exercise_index + 1) + "-" + (set_index % 4 + 1);
    };

    var rowClassFirst = function(exercise_index, set_index, workout_set) {
        var subset_length = workout_set.subset.length;
        var _icoin_style = "";
        if (workout_set.type == 2 || workout_set.type == 3) {
            if (exercise_index % 4 === 0) {
                _icoin_style = 'icon-left icomoon-a ';
            } else if (exercise_index % 4 === 1) {
                _icoin_style = 'icon-left icomoon-b ';
            } else if (exercise_index % 4 === 2) {
                _icoin_style = 'icon-left icomoon-c ';
            } else if (exercise_index % 4 === 3) {
                _icoin_style = 'icon-left icomoon-d ';
            }
        }
        if (set_index == subset_length - 1) return _icoin_style + "text-size10 ex-colour" + (exercise_index + 1) + "-" + (set_index % 4 + 1);
        else return _icoin_style + "item-borderbottom text-size10 ex-colour" + (exercise_index + 1) + "-" + (set_index % 4 + 1);
    };

    var headClass = function(exercise_index) {
        return "ex-colour" + (exercise_index + 1) + "-1 text-size12";
    };

    var headClassExercise = function(exercise_index, exercises_length) {
        if (exercises_length > 1) {
            var _icoin_style = "";
            if (exercise_index % 4 === 0) {
                _icoin_style = 'icon-left icomoon-a ';
            } else if (exercise_index % 4 === 1) {
                _icoin_style = 'icon-left icomoon-b ';
            } else if (exercise_index % 4 === 2) {
                _icoin_style = 'icon-left icomoon-c ';
            } else if (exercise_index % 4 === 3) {
                _icoin_style = 'icon-left icomoon-d ';
            }
            return _icoin_style + "ex-colour" + (exercise_index + 1) + "-1 text-size12";
        } else return "ex-colour" + (exercise_index + 1) + "-1 text-size12";
    };

    var widthFn = function(display_type, position) {
        if (position == 1) {
            if (display_type == 2) return "50%"; // time only 
            else if (display_type == 4) "25%"; // distance_time
            else if (display_type == 5) return "20%";
            else return "33.33%"; //1,3
        } else if (position == 2) {
            if (display_type == 2) return "50%";
            else if (display_type == 4) return "75%";
            else if (display_type == 5) return "80%";
            else return "66.67%";
        }
    };

    var tableStyle = function(_index, _length) {
        if (_index != _length - 1) {
            return "0 0 1px 0";
        } else {
            return "0 0 0 0";
        }
    };
    return {
        rowClass: rowClass,
        rowClassFirst: rowClassFirst,
        headClass: headClass,
        headClassExercise: headClassExercise,
        widthFn: widthFn,
        tableStyle: tableStyle
    }
});

gymstarapp.directive('fallbackSource', function() {
    return {
        link: function(scope, element, attributes) {
            if (sourceIsEmpty()) {
                useFallbackSource();
            } else {
                listenForSourceLoadingError();
            }

            function sourceIsEmpty() {
                var originalSource = element.attr('src');
                return originalSource ? false : true;
            }

            function useFallbackSource() {
                element.attr('src', attributes.fallbackSource);
            }

            function listenForSourceLoadingError() {
                element.bind('error', function() {
                    useFallbackSouce();
                });
            }
        }
    }
});

//full screen
gymstarapp.directive('fullscreen', function() {
    return {
        restrict: 'A',
        link: function(scope, element, attrs) {
            var _h = window.innerHeight;
            var _w = window.innerWidth;
            var _image_ratio = 16 / 9;
            var device_ratio = _h / _w;
            if (device_ratio > 16 / 9) { //
                //var _top=(_h-_w)/2;
                //var _left=(_w-_w*_image_ratio)/2;
                element.css({
                    //'max-height': '100vw',
                    //'height':'100vw',
                    'max-height': _w + 'px',
                    'height': _w + 'px',
                    'width': 'auto',
                    'position': 'absolute',
                    'top': (_h - _w) / 2 + 'px',
                    'left': (_w - _w * _image_ratio) / 2 + 'px',
                    '-moz-transform': 'rotate(90deg)',
                    '-webkit-transform': 'rotate(90deg)',
                    '-o-transform': 'rotate(90deg)',
                    '-ms-transform': 'rotate(90deg)',
                    'transform-origin': 'center center',
                });
            } else {
                //var _top=(_h-_h/_image_ratio)/2;
                //var _left=(_w-_h)/2;
                element.css({
                    //'max-width': '100vh',
                    //'width':'100vh',
                    'max-width': _h + 'px',
                    'width': _h + 'px',
                    'height': 'auto',
                    'position': 'absolute',
                    'top': (_h - _h / _image_ratio) / 2 + 'px',
                    'left': (_w - _h) / 2 + 'px',
                    '-moz-transform': 'rotate(90deg)',
                    '-webkit-transform': 'rotate(90deg)',
                    '-o-transform': 'rotate(90deg)',
                    '-ms-transform': 'rotate(90deg)',
                    'transform-origin': 'center center',
                });
            }
        }
    }
});
/*
//galleryfullscreen
gymstarapp.directive('galleryfullscreen', function () {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            var _h=window.innerHeight;
            var _w=window.innerWidth;
            var _image_ratio=16/9;
            var device_ratio=_h/_w;
            if(device_ratio>16/9){//
                //var _top=(_h-_w)/2;
                //var _left=(_w-_w*_image_ratio)/2;
                element.css({
                    'max-height': '100vw',
                    'height':'100vw',
                    'width':'auto',
                    'position':'absolute',
                    'top':(_h-_w*_image_ratio)/2+'px',
                    //'left':(_w-_w*_image_ratio)/2+'px',
                    '-moz-transform': 'rotate(90deg)',
                    '-webkit-transform': 'rotate(90deg)',
                    '-o-transform': 'rotate(90deg)',
                    '-ms-transform': 'rotate(90deg)',
                    'transform-origin':'center center',
                });
            }
            else
            {   
                //var _top=(_h-_h/_image_ratio)/2;
                //var _left=(_w-_h)/2;
                element.css({
                    'max-width': '100vh',
                    'width':'100vh',
                    'height':'auto',
                    'position':'absolute',
                    //'top':(_h-_h/_image_ratio)/2+'px',
                    'left':(_w-_h/_image_ratio)/2+'px',
                    '-moz-transform': 'rotate(90deg)',
                    '-webkit-transform': 'rotate(90deg)',
                    '-o-transform': 'rotate(90deg)',
                    '-ms-transform': 'rotate(90deg)',
                    'transform-origin':'center center',
                });
            }
        }
    }
});*/

gymstarapp.directive('imageonload', function($ionicLoading, $cordovaToast) {
    return {
        restrict: 'A',
        link: function(scope, element, attrs) {
            element.bind('load', function() {
                //console.log('load');
                //$ionicLoading.hide();
            });
            element.bind('abort', function() {
                //console.log('abort');
            });
            element.bind('error', function() {
                $cordovaToast.showShortCenter("Network error. Please try later!");
            });
        }
    };
});

gymstarapp.constant('angularMomentConfig', {
    preprocess: 'unix', // optional
    //timezone: 'Europe/London' // optional
});

moment.locale('en', {
    weekdaysShort: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],

    calendar: {
        lastDay: '[Yesterday at] LT',
        sameDay: '[Today at] LT',
        nextDay: '[Tomorrow at] LT',
        lastWeek: '[last] dddd [at] LT',
        nextWeek: 'dddd [at] LT',
        sameElse: 'L'
    },
    /*
    relativeTime : {
        future: "in %s",
        past:   "%s ago",
        s:  "s",
        m:  "a min",
        mm: "%d mins",
        h:  "an hr",
        hh: "%d hrs",
        d:  "a day",
        dd: "%d days",
        M:  "a month",
        MM: "%d months",
        y:  "a year",
        yy: "%d years"
    }*/
});

//1.0.0-rc.0
gymstarapp.config(function($ionicConfigProvider) {
    $ionicConfigProvider.views.swipeBackEnabled(false);
    $ionicConfigProvider.backButton.text('').icon('ion-arrow-left-c').previousTitleText(false);
    /*
    if (ionic.Platform.isIOS()) {
        $ionicConfigProvider.backButton.text('').icon('ion-chevron-left').previousTitleText(false);
    } else {
        $ionicConfigProvider.backButton.text('').icon('ion-arrow-left-c').previousTitleText(false);
    }*/

    //$ionicConfigProvider.views.maxCache(0);//only 0 working, default 10
});

gymstarapp.service('workoutService', function() {
    var _weightUnit = "kg";
    var _distanceUnit = "km";

    var _workoutPost = [];
    var _workout = {};
    var _workout_set = [{
        "type": -1,
        "subset": []
    }];
    var _exercises = []; //["exercise1", "exercise2", "exercise3", "exercise4"]
    var _exercises_type = [];
    var _exercises_cat = [];
    var _displayType = 1;

    var _superFlag = false;

    var _currentExerciseIndex = 0;
    var _postExercise = false;
    var _exercise_type = "default";

    var initial = function() {
        //_weightUnit = "Kg";
        _superFlag = false;
        //_distanceUnit = "m/Km";
        _workout = {};
        _workout_set = [{
            "type": -1,
            "subset": []
        }];
        _exercises.length = 0;
        _exercises_type.length = 0;
        _exercises_cat.length = 0;
        _workoutPost.length = 0;
        _displayType = 1;
        _exercise_type = "default";
        _currentExerciseIndex = 0;
        _postExercise = false;
    }

    var reset = function() {
        _workout = {};
        _workout_set = [{
            "type": -1,
            "subset": []
        }];
        _superFlag = false;
        _exercises = [];
        _exercises_type = [];
        _exercises_cat = [];
        _exercise_type = "default";
        _currentExerciseIndex = 0;
        _postExercise = false;
    }

    var setSuperFlag = function() {
        _superFlag = true;
    }

    var unsetSuperFlag = function() {
        _superFlag = false;
    }

    var getSuperFlag = function() {
            return _superFlag;
        }
        //set and get Unit 

    var setUnit = function(weightUnint, distanceUnit) {
        _weightUnit = weightUnint;
        _distanceUnit = distanceUnit;
    }

    var getUnit = function() {
        var _unit = {};
        _unit["weightUnit"] = _weightUnit;
        _unit["distanceUnit"] = _distanceUnit;
        return _unit;
    }

    //get post status: if true there are something to post else nothing to post.
    var getPostStatus = function() {
        if (_workoutPost.length == 0) return false;
        else return true;
    }

    var getExerciseCount = function() {
        var count = 0;
        for (var prop in _exercises) {
            if (_exercises.hasOwnProperty(prop)) {
                ++count;
            }
        }
        return count;
    }

    //set and get current exercise number;//1, 2, 3, 4
    var setExerciseIndex = function(number) {
        _currentExerciseIndex = number;
    }
    var getExerciseIndex = function() {
        return _currentExerciseIndex;
    }

    var setExercise = function(exerciseNumber, name, type, cat) {
        var indexNum = exerciseNumber;
        _exercises[indexNum] = name;
        _exercises_type[indexNum] = type;
        _exercises_cat[indexNum] = cat;
    }

    var deleteExercise = function(_index) {
        if (_index >= 0) {
            _exercises.splice(_index, 1);
            _exercises_type.splice(_index, 1);
            _exercises_cat.splice(_index, 1);
            if (_currentExerciseIndex != 0) _currentExerciseIndex--;
        }
    }

    var getExercise = function(exerciseNumber) {
        return _exercises[exerciseNumber];
    }

    var getExerciseType = function(exerciseNumber) {
        return _exercises_type[exerciseNumber];
    }

    var getExerciseCat = function(exerciseNumber) {
        return _exercises_cat[exerciseNumber];
    }

    var getExercises = function() {
        return _exercises;
    }

    var setExercises = function(exercises) {
        //_exercises = exercises;
        //get the _displayType
        //weight_reps only 1, time only 2, distance_time only 3, weight_reps +distance_time 5, weight_reps +time 4, all 5
        var tempType = _.uniq(_exercises_type);
        if (tempType.indexOf('other') > -1) {
            _displayType = 5; //all
        } else {
            if (tempType.indexOf('weight_reps') > -1) {

                if (tempType.indexOf('distance_time') > -1) {
                    _displayType = 5; //all
                } else if (tempType.indexOf('time') > -1) {
                    _displayType = 4; //weight_reps +time 
                } else {
                    _displayType = 1; //weight_reps only
                }
            } else // no weight
            {
                if (tempType.indexOf('distance_time') > -1) {
                    _displayType = 3; //distance time only
                } else if (tempType.indexOf('time') > -1) {
                    _displayType = 2; //time only
                }

            }
        }
    }

    var getWorkout = function() {
            _workout["exercises"] = _exercises;
            _workout["exercises_type"] = _exercises_type;
            _workout["display_type"] = _displayType;
            _workout["sets"] = _workout_set;
            return _workout;
        }
        //finish button to add workout to the workout post
    var addWorkout = function(__workout) {
        _workoutPost.push(__workout);
    }

    var setWorkoutPost = function(__workoutPost) {
        _workoutPost == __workoutPost;
    }
    var getWorkoutPost = function() {
        return _workoutPost;
    }

    return {
        initial: initial,
        reset: reset,
        addWorkout: addWorkout,
        setWorkoutPost: setWorkoutPost,
        getWorkoutPost: getWorkoutPost,
        setExerciseIndex: setExerciseIndex,
        getExerciseIndex: getExerciseIndex,
        getPostStatus: getPostStatus,
        getExerciseType: getExerciseType,
        getExerciseCat: getExerciseCat,
        setUnit: setUnit,
        getUnit: getUnit,
        getExerciseCount: getExerciseCount,
        setExercise: setExercise,
        getExercise: getExercise,
        deleteExercise: deleteExercise,
        setSuperFlag: setSuperFlag,
        unsetSuperFlag: unsetSuperFlag,
        getSuperFlag: getSuperFlag,
        getExercises: getExercises,
        setExercises: setExercises,
        getWorkout: getWorkout
    };
});
/*
gymstarapp.run(['$http', '$localStorage', function($http, $localStorage) {
    $http.defaults.headers.post['X-CSRF-Token'] = $localStorage.csrftoken;
}]);*/

gymstarapp.provider('myCSRF', [function() {
    var headerName = 'X-CSRF-Token';
    var cookieName = 'csrftoken';
    var allowedMethods = ['GET'];
    this.setHeaderName = function(n) {
        headerName = n;
    }
    this.setCookieName = function(n) {
        cookieName = n;
    }

    this.setAllowedMethods = function(n) {
        allowedMethods = n;
    }

    this.$get = ['$localStorage', function($localStorage) {
        return {
            'request': function(config) {
                if (allowedMethods.indexOf(config.method) === -1) {
                    // do something on success
                    config.headers[headerName] = $localStorage.csrftoken;
                }
                return config;
            }
        }
    }];
}]).config(function($httpProvider) {
    $httpProvider.interceptors.push('myCSRF');
});

gymstarapp.config(['$httpProvider', function($httpProvider) {
    $httpProvider.defaults.withCredentials = true;
    $httpProvider.defaults.headers.common['Content-Type'] = 'application/json';
}]);