'use strict'

/**
 * ExercisesCtrl
 * @param  {[type]} $scope         [description]
 * @param  {[type]} $state         [description]
 * @param  {[type]} workoutService [description]
 * @return {[type]}                [description]
 */

angular.module('controllers.exercisesSelect', ['ionic']).controller('ExercisesSelectCtrl', function($scope, Constants, $ionicModal, NotificationHandler, $ionicHistory, $ionicPopup, $timeout, $state, $filter, workoutService) {
    $scope.exercisesList = Constants.exercisesList;
    var exercises = workoutService.getExercises();
    $scope.workout = exercises;
    if (workoutService.getSuperFlag()) {
        $scope.superBtnShow = false;
        $scope.nextBtnShow = true;
    } else {
        $scope.superBtnShow = true;
        $scope.nextBtnShow = false;
    }

    $scope.exercises = Constants.exercises;
    $scope.exerciseClick = function(exerciseName, cat, type) {
        if($scope.settingsModal) $scope.settingsModal.hide();
        var currentExerciseIndex = workoutService.getExerciseIndex();
        workoutService.setExercise(currentExerciseIndex, exerciseName, type, cat);
        if (!workoutService.getSuperFlag()) //not super
        {
            workoutService.setExercises(workoutService.getExercises());
            $state.go("exercise_" + type, {
                exerciseName: workoutService.getExercise(currentExerciseIndex),
                indexId: currentExerciseIndex
            }, {
                reload: true
            });
        } else {
            currentExerciseIndex = currentExerciseIndex + 1;
            workoutService.setExerciseIndex(currentExerciseIndex);
            //$ionicHistory.clearCache();
            $state.go('selectexercise', {}, {
                reload: true
            });
        }
    }


    
    $scope.searchExe = function() {
        $ionicModal.fromTemplateUrl('templates/select_exercise_modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.settingsModal = modal;
            $scope.settingsModal.show();
        });
    };

    $scope.closeModal = function() {
        $scope.settingsModal.hide();
    }

    $scope.deleteExe = function(_index) {
        var _exercises = workoutService.getExercises();
        if (_exercises.length != 0 && _index <= _exercises.length - 1) {
            workoutService.deleteExercise(_index);
            $scope.workout = workoutService.getExercises();
        }
    }

    $scope.customClick = function() {
        $scope.data = {};
        //$scope.data.exerciseName = workoutService.getExercise(exerciseNumber-1);
        //var exerciseType=workoutService.getExerciseType(exerciseNumber-1);
        var cat = "Other";
        if (typeof exerciseType == 'undefined' || exerciseType == "other") {
            var _title = "New Exercise";
            var _msg = "Enter new exercise name";
            var _text = $scope.data.exerciseName || "";

            NotificationHandler.prompt(_msg, _title, _text).then(function(result) {

                var input = result.input1;
                var btnIndex = result.buttonIndex;

                var currentExerciseIndex = workoutService.getExerciseIndex();
                var type = "other";
                if (btnIndex == 2) {
                    if (!input) {
                        NotificationHandler.alert("Please enter the exercise name");
                    } else {
                        workoutService.setExercise(currentExerciseIndex, input, type, cat);
                        if (!workoutService.getSuperFlag()) {
                            $state.go("exercise_other", {
                                exerciseName: input,
                                indexId: 0
                            });
                        } else {
                            currentExerciseIndex = currentExerciseIndex + 1;
                            workoutService.setExerciseIndex(currentExerciseIndex);
                            $state.go('selectexercise');
                        }
                    }
                }
            });
        }
    }

    $scope.categoryClick = function(pathParam) {
            if (exercises.length >= 4) {
                $ionicPopup.alert({
                    title: 'Alert',
                    template: 'Maximum 4 exercises!'
                });
            } else {
                $state.go(pathParam);
            }
        }
        //next function: go to the first exercise and input some values
    $scope.nextBtn = function() {
        //need to pop up the empty element in the array;
        var _exercises = workoutService.getExercises();
        _exercises = _exercises.filter(function(n) {
            return n != ""
        });
        workoutService.setExercises(_exercises);
        //end of the code to clean up the empty element in the exercises array;
        $ionicHistory.clearCache();

        workoutService.setExerciseIndex(0);
        $state.go("exercise_" + workoutService.getExerciseType(0), {
            exerciseName: workoutService.getExercise(0),
            indexId: 0
        }, {
            reload: true
        });
    }
    $scope.superBtn = function() {
            $scope.superBtnShow = false;
            $scope.nextBtnShow = true;
            $scope.workout = []
            $scope.workouts = [];
            workoutService.reset();
            workoutService.setSuperFlag();
        }
        //Cancel Function
    $scope.cancelFn = function() {
        $scope.workouts = [];
        $scope.superBtnShow = true;
        $scope.nextBtnShow = false;
        workoutService.reset();
        //$ionicHistory.clearCache();
        $state.go('tabs.postworkout');
    }
}).controller('Exercises_SelectCtrl', function($scope, Constants, $ionicHistory, $timeout, $state, workoutService) {
    //$scope.exercisesList = Constants.exercisesList;
    $scope.exercises = Constants.exercises;
    $scope.exerciseClick = function(exerciseName, cat, type) {
        var currentExerciseIndex = workoutService.getExerciseIndex();
        workoutService.setExercise(currentExerciseIndex, exerciseName, type, cat);
        if (!workoutService.getSuperFlag()) //not super
        {
            workoutService.setExercises(workoutService.getExercises());
            $state.go("exercise_" + type, {
                exerciseName: workoutService.getExercise(currentExerciseIndex),
                indexId: currentExerciseIndex
            }, {
                reload: true
            });
        } else {
            currentExerciseIndex = currentExerciseIndex + 1;
            workoutService.setExerciseIndex(currentExerciseIndex);
            //$ionicHistory.clearCache();
            $state.go('selectexercise', {}, {
                reload: true
            });
        }
    }
});