'use strict'
/**
 * ExerciseTimeCtrl
 * @param  {[type]} $scope         [description]
 * @param  {[type]} $state         [description]
 * @param  {[type]} workoutService [description]
 * @return {[type]}                [description]
 */
angular.module('controllers.timeExercise', ['ionic']).controller('ExerciseTimeCtrl', function($scope, $state, $ionicModal, $ionicPopup, workoutService, workoutStyle, $ionicViewSwitcher) {
    var exercises = workoutService.getExercises();
    var currentExerciseIndex = workoutService.getExerciseIndex();
    var exerciseName = exercises[currentExerciseIndex];
    $scope.currentExerciseName = exerciseName;
    $scope.saveButtonShow = true;
    $scope.superButton = true;
    $scope.dropButton = true;
    $scope.finishButton = true;
    //$scope.undoButton = true;
    //get the workout to display or get the empty object;
    $scope.workouts = workoutService.getWorkout();

    var _unit = workoutService.getUnit();
    //get the weight Unit
    $scope.weightUnit = _unit.weightUnit;
    $scope.distanceUnit = _unit.distanceUnit;

    if ($scope.workouts != "" && $scope.workouts.sets.length != 0) {
        var __sets = $scope.workouts.sets;
        var __set = __sets[__sets.length - 1];
        if (__set.type == 3) {
            if (currentExerciseIndex == 0) {
                $scope.dropButton = false;
                $scope.saveButton = true;
                $scope.superButton = false;
            } else { //currentExerciseIndex != 0
                if (__set.subset[__set.subset.length - 1].exercise != exerciseName) //forward
                {
                    $scope.dropButton = true;
                    $scope.saveButton = false;
                    $scope.superButton = true;
                } else {
                    $scope.dropButton = false;
                    $scope.saveButton = true;
                    if (currentExerciseIndex == exercises.length - 1) $scope.superButton = true;
                    else $scope.superButton = false;
                }
            }
        }
    }
    /*
    $scope.rightBtnFn = function(_rightBtnText) {
        if (_rightBtnText == 'Edit') {
            $scope.leftBtnText = 'Delete';
            $scope.rightBtnText = 'Done';
            $scope.showDelete = false;
            $scope.showReorder = true;
        } else {
            $scope.settingsModal.remove();
            $scope.showDelete = false;
            $scope.showReorder = false;
        }

    }

    $scope.leftBtnFn = function(_leftBtnText) {
        if (_leftBtnText == 'Delete') {
            $scope.showDelete = true;
            $scope.showReorder = false;
            $scope.leftBtnText = 'Reorder';
        } else if (_leftBtnText == 'Reorder') {
            $scope.showReorder = true;
            $scope.leftBtnText = 'Delete';

        } else if (_leftBtnText == 'Back') {
            $scope.settingsModal.remove();
            $scope.showDelete = false;
            $scope.showReorder = false;
        }
    }
    $scope.onHold = function() {
        if (!$scope.saveButtonShow) {
            $ionicModal.fromTemplateUrl('templates/exercises.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.settingsModal = modal;
                $scope.leftBtnText = 'Back';
                $scope.rightBtnText = 'Edit';
                $scope.settingsModal.show();
            });
        } else {
            $ionicPopup.alert({
                title: 'Information',
                template: 'If you want to edit the exercises, please save the whole set first!'
            });
        }
    };

    $scope.moveExercise = function(_fromIndex, _toIndex) {
            var tempExercise = $scope.workouts.sets[_fromIndex];
            $scope.workouts.sets.splice(_fromIndex, 1);
            $scope.workouts.sets.splice(_toIndex, 0, tempExercise);
        }
        */


    /**
     * newset function: start up a new set
     */
    $scope.newset = function() {
            //create new set in sets array;
            $scope.workouts.sets.push({
                "type": -1,
                "subset": []
            });
            $scope.currentExerciseName = exercises[0];
            //show the save button
            $scope.saveButtonShow = true;
            //disable the finish button untill the save function to enable it
            $scope.finishButton = true;
            //disable the drop button untill the save function to enable it
            $scope.dropButton = true;
            //$scope.undoButton = true;
            if (exercises.length > 1) {
                workoutService.setExerciseIndex(0); //change the exercise index back to 0
                $state.go("exercise_" + workoutService.getExerciseType(0), {}, {
                    reload: true
                });
            }
        }
        /**
         * save function: save the current input into the sets array.
         */
    $scope.save = function(workout) {
        // maximum sets in one post
        if ($scope.workouts.sets.length == 49) $scope.newSetButton = true;
        if ($scope.dropButton) $scope.dropButton = false;
        $scope.undoButton = false;
        var _workout_subset = {};
        _workout_subset["weight"] = "-1";
        _workout_subset["reps"] = "-1";
        _workout_subset["distance"] = "-1";
        var tempHour = 0;
        var tempMinute = 0;
        var tempSecond = 0;
        if (workout.timehour) tempHour = workout.timehour;
        if (workout.timeminute) tempMinute = workout.timeminute;
        if (workout.timesecond) tempSecond = workout.timesecond;
        _workout_subset["time"] = tempHour * 3600 + tempMinute * 60 + tempSecond;

        currentExerciseIndex = workoutService.getExerciseIndex();
        _workout_subset["exercise"] = exercises[currentExerciseIndex];
        _workout_subset["exercise_type"] = workoutService.getExerciseType(currentExerciseIndex);
        _workout_subset["category"] = workoutService.getExerciseCat(currentExerciseIndex);
        if (exercises.length > 1) //deal with super set
        {
            if (currentExerciseIndex == 0) //save the first super set
            {
                //console.log("test");
                $scope.superButton = false; // enable the super button
                $scope.saveButton = true; // disabled the save button until super button move to the next exercise.
                var _sets = $scope.workouts.sets;
                var _subsets = _sets[_sets.length - 1];
                if (!_subsets || _subsets.type == -1 || !_subsets.subset || _subsets.subset == "") // brand new 
                {
                    var _set = {};
                    var _subset = [];
                    _subset.push(_workout_subset);
                    _set["type"] = 2;
                    _set["subset"] = _subset;
                    $scope.workouts.sets.pop();
                    $scope.workouts.sets.push(_set);
                }
            } else {
                if (currentExerciseIndex == exercises.length - 1) // save the last super set
                {
                    $scope.saveButtonShow = false;
                    $scope.superButton = true;
                    $scope.saveButton = false;
                    $scope.finishButton = false; //enable finish button 
                    //$scope.undoButton = false;
                } else // other super set
                {
                    $scope.saveButtonShow = true;
                    $scope.saveButton = true;
                    $scope.superButton = false;
                    // $scope.undoButton = true;
                }

                var _sets = $scope.workouts.sets;
                if ($scope.workouts.sets[_sets.length - 1].type == 1) $scope.workouts.sets[_sets.length - 1].type == 3;
                $scope.workouts.sets[_sets.length - 1].subset.push(_workout_subset);
            }
        } else //normal set
        {
            var _set = {};
            var _subsets = [];
            _subsets.push(_workout_subset);
            _set["type"] = 0;
            _set["subset"] = _subsets;
            $scope.workouts.sets.pop();
            $scope.workouts.sets.push(_set);
            $scope.finishButton = false;
            $scope.saveButtonShow = false;
            //$scope.undoButton = false;
        }
        //console.log($scope.workouts);
    }

    /**
     * undoFn function
     */
    $scope.undoFn = function() {
            var workout_set = $scope.workouts.sets;
            var _set = workout_set[workout_set.length - 1];
            var currentExerciseIndex = workoutService.getExerciseIndex();
            if (_set.type == -1) {
                $scope.workouts.sets.pop();
                $scope.saveButtonShow = false;
                if ($scope.workouts.sets.length < 1) $scope.undoButton = true;
                else $scope.finishButton = false;
            } else if (_set.type == 0) {
                $scope.workouts.sets.pop();
                $scope.dropButton = true;
                $scope.superButton = true;
                if (workout_set.length <= 0) {
                    $scope.workouts.sets.push({
                        "type": -1,
                        "subset": []
                    });
                    $scope.undoButton = true;
                    $scope.saveButtonShow = true;
                    $scope.finishButton = true;
                } else if (exercises.length > 0) {
                    $scope.saveButtonShow = false;
                    $scope.finishButton = false;
                }
            } else if (_set.type == 1) //drop set
            {
                if (_set.subset.length <= 1) {
                    if (workout_set.length <= 1) {
                        $scope.saveButtonShow = true;
                        $scope.dropButton = true;
                        $scope.undoButton = true;
                    }
                    $scope.workouts.sets.pop();
                } else {
                    if (_set.subset.length == 2) $scope.workouts.sets[workout_set.length - 1].type = 0;
                    $scope.workouts.sets[workout_set.length - 1].subset.pop();
                    $scope.dropButton = false;
                }
            } else if (_set.type == 2) //super set
            {
                if (currentExerciseIndex == 0) {
                    if (exercises[currentExerciseIndex] != _set.subset[_set.subset.length - 1].exercise) {
                        currentExerciseIndex = exercises.length - 1;
                        workoutService.setExerciseIndex(currentExerciseIndex);
                        $scope.workouts.sets[workout_set.length - 1].subset.pop();
                        $state.go("exercise_" + workoutService.getExerciseType(currentExerciseIndex), {}, {
                            reload: true
                        });
                    } else {
                        if (workout_set.length <= 1) { //only one set
                            $scope.undoButton = true;
                            $scope.saveButton = false;
                            $scope.superButton = true;
                            $scope.dropButton = true;
                            $scope.workouts.sets.pop();
                            $scope.workouts.sets.push({
                                "type": -1,
                                "subset": []
                            });
                        } else { // more than one set
                            $scope.workouts.sets.pop();
                            $scope.workouts.sets.push({
                                "type": -1,
                                "subset": []
                            });
                            $scope.superButton = true;
                            $scope.dropButton = true;
                            $scope.saveButtonShow = true;
                            $scope.saveButton = false;
                            $scope.finishButton = true;
                        }
                    }
                } else {
                    if (exercises[currentExerciseIndex] != _set.subset[_set.subset.length - 1].exercise) {
                        if (currentExerciseIndex == 1) {
                            $scope.workouts.sets.pop();
                            $scope.workouts.sets.push({
                                "type": -1,
                                "subset": []
                            });
                        } else $scope.workouts.sets[workout_set.length - 1].subset.pop();
                        currentExerciseIndex--;
                        workoutService.setExerciseIndex(currentExerciseIndex);
                        $state.go("exercise_" + workoutService.getExerciseType(currentExerciseIndex), {}, {
                            reload: true
                        });
                    } else {
                        $scope.workouts.sets[workout_set.length - 1].subset.pop();
                        $scope.saveButtonShow = true;
                        $scope.superButton = true;
                        $scope.dropButton = true;
                        $scope.saveButton = false;
                    }
                }
            } else if (_set.type == 3) //hyrid set
            {
                if (currentExerciseIndex == 0) {
                    //delete the last susbset of the last set. undo a new set.
                    if (exercises[currentExerciseIndex] != _set.subset[_set.subset.length - 1].exercise) {
                        currentExerciseIndex = exercises.length - 1;
                        workoutService.setExerciseIndex(currentExerciseIndex);
                        $scope.workouts.sets[workout_set.length - 1].subset.pop();
                        $state.go("exercise_" + workoutService.getExerciseType(currentExerciseIndex), {}, {
                            reload: true
                        });
                    } else {
                        if (_set.subset.length == 2) $scope.workouts.sets[workout_set.length - 1].type = 2;
                        $scope.workouts.sets[workout_set.length - 1].subset.pop();
                        $scope.dropButton = false;
                        $scope.saveButton = true;
                        $scope.superButton = false;
                    }
                } else {
                    //current exercise != the last exercise name in the list. 
                    if (exercises[currentExerciseIndex] != _set.subset[_set.subset.length - 1].exercise) {
                        currentExerciseIndex--;
                        workoutService.setExerciseIndex(currentExerciseIndex);
                        $scope.workouts.sets[workout_set.length - 1].subset.pop();
                        var _length = $scope.workouts.sets[workout_set.length - 1].subset.length;
                        var currentSubset = $scope.workouts.sets[workout_set.length - 1].subset;
                        if (_length == 1 || currentSubset[_length - 1].exercise != currentSubset[_length - 2].exercise) $scope.workouts.sets[workout_set.length - 1].type = 2;
                        $state.go("exercise_" + workoutService.getExerciseType(currentExerciseIndex), {}, {
                            reload: true
                        });
                    } else if (_set.subset[_set.subset.length - 2].exercise != _set.subset[_set.subset.length - 1].exercise) {
                        $scope.workouts.sets[workout_set.length - 1].subset.pop();
                        if ($scope.workouts.sets[workout_set.length - 1].subset.length == 1) $scope.workouts.sets[workout_set.length - 1].type = 2;
                        $scope.dropButton = true;
                        $scope.superButton = true;
                        $scope.saveButtonShow = true;
                        $scope.saveButton = false;
                        $scope.finishButton = true;
                    } else {
                        if ($scope.workouts.sets[workout_set.length - 1].subset.length == exercises.length + currentExerciseIndex - 1) $scope.workouts.sets[workout_set.length - 1].type = 2;
                        if (currentExerciseIndex != exercises.length - 1) $scope.superButton = false;
                        else $scope.superButton = true;
                        $scope.dropButton = false;
                        $scope.saveButton = true;
                        $scope.workouts.sets[workout_set.length - 1].subset.pop();
                    }
                }
            }
        }
        /**
         * super function: move to next exercise
         * @return {[type]} [description]
         */
    $scope.super = function() {
        $scope.superButton = true; //disable the super button untill save the input
        $scope.saveButton = false; //enable the save button to save some input
        $scope.undoButton = false;
        if (currentExerciseIndex != exercises.length - 1) // not last exercise set
        {
            $scope.dropButton = true;
            currentExerciseIndex++;
            workoutService.setExerciseIndex(currentExerciseIndex);
            $state.go("exercise_" + workoutService.getExerciseType(currentExerciseIndex), {}, {
                reload: true
            });
        }
    }

    /**
     * drop function
     * @param  {[type]} workout [description]
     * @return {[type]}         [description]
     */
    $scope.drop = function(workout) {
        var _workout = $scope.workouts;
        var currentPos = _workout.sets.length - 1;
        var _sets = _workout.sets[currentPos];
        var exerciseLength = _.reduce(_sets.subset, function(memo, elem) {
            if (elem.exercise == exercises[currentExerciseIndex]) memo++;
            return memo;
        }, 0);
        if (exerciseLength < 4) {
            var _workout_subset = {};
            _workout_subset["weight"] = "-1";
            _workout_subset["reps"] = "-1";
            _workout_subset["distance"] = "-1";
            var tempHour = 0;
            var tempMinute = 0;
            var tempSecond = 0;
            if (workout.timehour) tempHour = workout.timehour;
            if (workout.timeminute) tempMinute = workout.timeminute;
            if (workout.timesecond) tempSecond = workout.timesecond;
            _workout_subset["time"] = tempHour * 3600 + tempMinute * 60 + tempSecond;
            _workout_subset["exercise"] = exercises[currentExerciseIndex];
            _workout_subset["exercise_type"] = workoutService.getExerciseType(currentExerciseIndex);
            _workout_subset["category"] = workoutService.getExerciseCat(currentExerciseIndex);
            $scope.workouts.sets[currentPos].subset.push(_workout_subset);
            if (exercises.length == 1) $scope.workouts.sets[currentPos].type = 1; //change to drop
            else $scope.workouts.sets[currentPos].type = 3; //change to hybrid
            //if($scope.workouts.sets[currentPos].subset.length==4)
            if (exerciseLength == 3) {
                $scope.dropButton = true;
                if (currentExerciseIndex == exercises.length - 1) $scope.saveButtonShow = false;
            }
        }
    }

    /**
     * finish function: save the $scope.workouts to the workoutService
     * @return {[type]} [description]
     */
    $scope.finishFn = function() {
        var workout = $scope.workouts;
        workoutService.addWorkout(workout);
        console.log();
        $scope.workouts = [];
        workoutService.reset();
        $ionicViewSwitcher.nextDirection('back');
        $state.go('tabs.postworkout');
    }


    $scope.cancelFn = function() {
        $scope.workouts = [];
        workoutService.reset();
        $ionicViewSwitcher.nextDirection('back');
        $state.go('selectexercise');
    }

    $scope.rowClass = function(exercise_index, set_index, subset_length) {
        return workoutStyle.rowClass(exercise_index, set_index, subset_length);
    };

    $scope.headClass = function(exercise_index, exercises_length) {
        return workoutStyle.headClassExercise(exercise_index, exercises_length);
    };
    $scope.rowClassFirst = function(exercise_index, set_index, workout_set) {
        return workoutStyle.rowClassFirst(exercise_index, set_index, workout_set);
    };
});