'use strict'

angular.module('controllers.workoutPost', ['ionic']).controller('PostWorkoutCtrl', function($scope, $state, $ionicModal, workoutStyle, $ionicPopup, $ionicHistory, workoutService) {
    $scope.workoutpost = {};

    $scope.workoutpost.postButton = true;
    $scope.workoutpost.tableShow = false;

    if (workoutService.getPostStatus()) {
        $scope.workoutpost.postButton = false;
        $scope.workoutpost.tableShow = true;
        $scope.workoutpost.weightUnit = workoutService.getUnit().weightUnit;
        $scope.workoutpost.distanceUnit = workoutService.getUnit().distanceUnit;
        $scope.workoutpost.workoutPost = workoutService.getWorkoutPost();
    }


    $scope.rightBtnFn = function(_rightBtnText) {
        if (_rightBtnText == 'Edit') {
            $scope.workoutpost.leftBtnText = 'Delete';
            $scope.workoutpost.rightBtnText = 'Done';
            $scope.workoutpost.showDelete = false;
            $scope.workoutpost.showReorder = true;
        } else {
            $scope.workoutpost.settingsModal.remove();
            $scope.workoutpost.showDelete = false;
            $scope.workoutpost.showReorder = false;
        }
    }

    $scope.leftBtnFn = function(_leftBtnText) {
        if (_leftBtnText == 'Delete') {
            $scope.workoutpost.showDelete = true;
            $scope.workoutpost.showReorder = false;
            $scope.workoutpost.leftBtnText = 'Reorder';
        } else if (_leftBtnText == 'Reorder') {
            $scope.workoutpost.showReorder = true;
            $scope.workoutpost.leftBtnText = 'Delete';

        } else if (_leftBtnText == 'Back') {
            $scope.workoutpost.settingsModal.remove();
            $scope.workoutpost.showDelete = false;
            $scope.workoutpost.showReorder = false;
        }
    }

    /*
    $scope.onHold = function() {
      $ionicModal.fromTemplateUrl('templates/workoutposts.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.workoutpost.settingsModal = modal;
        $scope.workoutpost.leftBtnText = 'Back';
        $scope.workoutpost.rightBtnText = 'Edit';
        $scope.workoutpost.settingsModal.show();
      });
    };*/

    $scope.cancelFn = function() {
        workoutService.initial();
        //$ionicHistory.clearCache();
        $state.go('tabs.livefeed', {
            refreshFlag: 0
        });
    }

    $scope.postFn = function() {
        var _workoutPost = $scope.workoutpost.workoutPost;
        workoutService.setWorkoutPost(_workoutPost);
        //$ionicHistory.clearCache();
        $state.go('shareworkout');
    }


    $scope.moveItem = function(_fromIndex, _toIndex) {
        var tempExercise = $scope.workoutpost.workoutPost[_fromIndex];
        $scope.workoutpost.workoutPost.splice(_fromIndex, 1);
        $scope.workoutpost.workoutPost.splice(_toIndex, 0, tempExercise);
    }


    $scope.rowClass = function(exercise_index, set_index, subset_length) {
        return workoutStyle.rowClass(exercise_index, set_index, subset_length);
    };

    $scope.headClass = function(exercise_index) {
        return workoutStyle.headClass(exercise_index);
    };
    $scope.rowClassFirst = function(exercise_index, set_index, subset_length) {
        return workoutStyle.rowClassFirst(exercise_index, set_index, subset_length);
    };

    $scope.widthFn = function(display_type, position) {
        return workoutStyle.widthFn(display_type, position);
    };

    $scope.tableStyle = function(_index, _length) {
        return workoutStyle.tableStyle(_index, _length);
    };
});