'use strict'

var app = angular.module('controllers.search', ['ionic']);
gymstarapp.controller('SearchUserCtrl', function($scope, $state, $localStorage, $ionicLoading, $http, ErrorHandler, workoutStyle, $stateParams, $cordovaActionSheet, Constants, $ionicModal, $timeout, $q, $cordovaDialogs, serviceUser, $cordovaProgress) {
    var searchUserIndex = 0;
    var CONSTANT_TIMEOUT=Constants.timeout;
    var _search = $localStorage.usersearch;
    var displayUser = $localStorage.loginuser;
    var userId = displayUser.uid;
    var serviceUrl = Constants.API.serviceUrl;
    $scope.data = {};
    var _countries=angular.copy(Constants.countryList);

    _countries.unshift('All');
    $scope.countries = _countries;
    $scope.fields = Constants.searchField;
    if (_search) {
        $scope.data = _search;
    } else {
        $scope.data.selectedCountry = $scope.countries[197];
        $scope.data.selectedField = $scope.fields[0];
        $scope.data.searchusers = [];
        $scope.data.noMoreUserAvailable = true;
    }

    $scope.searchUser = function() {
        $scope.data.searchusers = [];
        var _value = $scope.data.searchValue;
        var _field = $scope.data.selectedField;
        var _country = $scope.data.selectedCountry;
        var _page = searchUserIndex;
        $scope.data.noMoreUserAvailable = true;
        $scope.data.searchUserIndex = searchUserIndex;
        if (!_value) ErrorHandler.alertPopupTitle('Search should not be empty.', 'Error');
        else {
            _field = _field.toLowerCase();
            _field = _field.replace(/\s+/, '');
            loadUser(userId, _field, _value, _page, _country);
        }
    }

    $scope.navTo = function(_uid) {
        if (_uid == userId) {
            $state.go('tabs.myprofile');
        } else {
            $state.go('visitorprofile', {
                target: _uid
            });
        }
    }

    $scope.loadMoreUser = function() {
        loadUser(userId, _field, _value, $scope.data.searchUserIndex, _country);
    }

    var loadUser = function(_uid, _field, _value, _page, _country) {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner>',
            duration:CONSTANT_TIMEOUT
        });
        //console.log(serviceUrl + "/user/" + _uid + "/search/" + _field + "/" + _value + "/" + _country + "/" + _page);
        $http.post(serviceUrl + "/user/" + _uid + "/search/" + _field + "/" + _value + "/" + _country + "/" + _page, {}, {timeout:CONSTANT_TIMEOUT}).then(function(response) {
            $ionicLoading.hide();
            if (response.data.length != 0) {
                if (response.data.length < 8) $scope.data.noMoreUserAvailable = true;
                else {
                    $scope.data.noMoreUserAvailable = false;
                    $scope.data.searchUserIndex++;
                }
                $scope.data.searchusers = $scope.data.searchusers.concat(response.data);
                $localStorage.usersearch = $scope.data;
            } else {
                $scope.data.noMoreUserAvailable = true;
                ErrorHandler.alertPopupTitle('No user found, please check and try again.', 'No Users Found');
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }
});

gymstarapp.controller('SearchWorkoutCtrl', function($scope, $state, $localStorage, workoutStyle, serviceComment, $ionicLoading, $http, ErrorHandler, $stateParams, $cordovaActionSheet, Constants, $ionicModal, $timeout, $q, $cordovaDialogs, serviceUser, $cordovaProgress) {
    var _search = $localStorage.workoutsearch;
    var displayUser = $localStorage.loginuser;
    var userId = displayUser.uid;
    var serviceUrl = Constants.API.serviceUrl;
    var CONSTANT_TIMEOUT=Constants.timeout;
    var userName = displayUser.name;
    $scope.weightUnit = displayUser.weightUnit;
    $scope.distanceUnit = displayUser.distanceUnit;
    $scope.userId = userId;
    $scope.summaryToggle = true;
    if (_search) {
        $scope.data = _search;
    } else {
        $scope.data = {};
        $scope.data.selectedGender = 0;
        $scope.data.selectedAge = 0;
        $scope.data.selectedWeight = 0;
        $scope.data.selectedSortBy = 0;
        $scope.data.workoutlist = [];
        $scope.data.searchIndex = 0;
        $scope.data.noMoreWorkoutAvailable = true;
    }

    $scope.searchWorkout = function() {
        $scope.data.workoutlist = [];
        $scope.data.searchIndex = 0;
        var _value = $scope.data.textField;
        $scope.data.noMoreWorkoutAvailable = true;
        if (!_value) ErrorHandler.alertPopupTitle('Search should not be empty.', 'Error');
        else {
            $scope.showWorkouts();
        }
    }


    $scope.showWorkouts = function() {
        $ionicModal.fromTemplateUrl('templates/profile_workout_modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.workoutmodal = modal;
            loadFunction();
        });
    }

    $scope.closeWorkouts = function() {
        $scope.workoutmodal.remove();
    }

    var loadFunction = function() {
        var parameters = {};
        parameters['searchtext'] = $scope.data.textField;
        parameters['gender'] = $scope.data.selectedGender;
        parameters['sortBy'] = $scope.data.selectedSortBy;
        parameters['age'] = $scope.data.selectedAge;
        parameters['weight'] = $scope.data.selectedWeight;
        parameters['page'] = $scope.data.searchIndex;
        loadWorkout(parameters);
    }

    var loadWorkout = function(_params) {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner>',
            duration:CONSTANT_TIMEOUT
        });
        $http.get(serviceUrl + "/workoutpost?", {
            params: {
                "parameters[gender]": _params['gender'],
                "parameters[searchtext]": _params['searchtext'],
                "parameters[sortBy]": _params['sortBy'],
                "parameters[age]": _params['age'],
                "parameters[weight]": _params['weight'],
                "parameters[page]": _params['page']
            },
            timeout:CONSTANT_TIMEOUT
        }).then(function(response) {
            $ionicLoading.hide();
            if (response.data.length != 0) {
                if (response.data.length < 8) $scope.data.noMoreItemAvailable = true;
                else {
                    $scope.data.noMoreWorkoutAvailable = false;
                    $scope.data.searchIndex++;
                }
                $scope.data.workoutlist = $scope.data.workoutlist.concat(response.data);
                $localStorage.workoutsearch = $scope.data;
                $scope.workoutmodal.show();
            } else {
                $scope.data.noMoreWorkoutAvailable = true;
                ErrorHandler.alertPopupTitle('no result found, please check and try again.', 'No Results Found');
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    $scope.loadMoreWorkout = function() {
        loadFunction();
    }

    $scope.data.noMoreRecommendAvailable = true;
    $scope.recommendIndex = 0;
    $scope.recommends = [];
    var loadRecommend = function(_index, _workoutId, _flag) {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner>',
            hideOnStageChange: true,
            duration:CONSTANT_TIMEOUT
        });
        $http.post(serviceUrl + "/node/" + _workoutId + "/load_recommends/" + _index,{},{timeout:CONSTANT_TIMEOUT}).then(function(response) {
            if (response.data.length != 0) {
                if (response.data.length < 8) $scope.data.noMoreRecommendAvailable = true;
                else {
                    $scope.data.noMoreRecommendAvailable = false;
                    $scope.recommendIndex++;
                }
                var recommends = response.data;
                if (_flag) {
                    $scope.recommends = $scope.recommends.concat(recommends);
                } else $scope.recommends = recommends;
            } else {
                $scope.data.noMoreRecommendAvailable = true;
            }
            $ionicLoading.hide();
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    $scope.loadMoreRecommends = function(_nid) {
        loadRecommend($scope.recommendIndex, _nid, true);
    }

    $scope.openRecommendModal = function(_nid) {
        $ionicModal.fromTemplateUrl('modal_1.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_1 = modal;
            $scope.currentNID = _nid;
            loadRecommend($scope.recommendIndex, _nid, false);
            $scope.modal_1.show();
        });
    }


    //Comment
    $scope.data.shouldShowCommentDelete = false;
    $scope.data.listCommentCanSwipe = true;

    $scope.data.noMoreCommentAvailable = true;
    $scope.commentIndex = 0;
    $scope.comments = [];
    var loadComment = function(_index, _nid, _flag) {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner>',
            duration:CONSTANT_TIMEOUT
        });
        serviceComment.query({
            'parameters[nid]': _nid,
            page: _index,
            pagesize: 20
        }).$promise.then(function(results) {
            if (results.length != 0) {
                if (results.length < 20) $scope.data.noMoreCommentAvailable = true;
                else {
                    $scope.data.noMoreCommentAvailable = false;
                    $scope.commentIndex++;
                }
                var comments = results;
                if (_flag) {
                    $scope.comments = $scope.comments.concat(comments);
                } else $scope.comments = comments;
            } else {
                $scope.data.noMoreCommentAvailable = true;
            }
            $ionicLoading.hide();
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }


    $scope.loadMoreComments = function(_nid) {
        loadComment($scope.commentIndex, _nid, true);
    }

    $scope.openCommentModal = function(_workout, _flag, _index) { //_flag : true open the keyboard;
        $ionicModal.fromTemplateUrl('modal_2.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_2 = modal;
            $scope.currentNID = _workout.nid;
            $scope.currentIndex = _index;
            $scope.currentUID = _workout.uid;
            $scope.currentUsername = _workout.name;
            loadComment($scope.commentIndex, _workout.nid, false);
            $scope.modal_2.show();
        });
    }


    $scope.deleteComment = function(_index, _type) {
        var _cid = $scope.comments[_index].cid;
        serviceComment.remove({
            id: _cid
        }).$promise.then(function(results) {
            if (results[0]) {
                $scope.comments.splice(_index, 1);
                if (_type) { //fav
                    $scope.favouriteList[$scope.currentIndex].comment_count--;
                } else {
                    $scope.data.workoutlist[$scope.currentIndex].comment_count--;
                }
            }
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    $scope.sendComment = function(_msg) {
        var _comment = {
            "nid": $scope.currentNID,
            "comment_body": {
                "und": [{
                    "value": _msg
                }]
            }
        }
        serviceComment.post(_comment).$promise.then(function(results) {
            $scope.comments = $scope.comments.concat(results);
            if ($scope.data.type) { //fav
                $scope.favouriteList[$scope.currentIndex].comment_count++;
                $scope.favouriteList[$scope.currentIndex].commented = true;
            } else {
                $scope.data.workoutlist[$scope.currentIndex].comment_count++;
                $scope.data.workoutlist[$scope.currentIndex].commented = true;
            }
            $scope.data.commentMessage = "";
            if (user.id != $scope.currentUID) {
                NotificationService.send(user.name, user.uid, $scope.currentUsername, $scope.currentUID, $scope.currentNID, 4);
            }
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    $scope.closeModal = function(_id) {
        if (_id === 1) {
            $scope.modal_1.remove().then(function() {
                $scope.recommends = [];
                $scope.data.noMoreRecommendAvailable = true;
                $scope.recommendIndex = 0;
            });
        }
        if (_id === 2) {
            $scope.modal_2.remove().then(function() {
                $scope.comments = [];
                $scope.data.noMoreCommentAvailable = true;
                $scope.commentIndex = 0;
            });

        }
    }

    var favRecFunction = function(_nid, _action) {
        return $http.post(serviceUrl + '/node/' + _nid + '/' + _action,{},{timeout:CONSTANT_TIMEOUT})
    }

    $scope.favouriteClick = function(_nid, _status, _index, _type) {
        if (_status == 0) { //action, favourite
            favRecFunction(_nid, 'favourite').then(function(response) {
                if (response.status == 200) {
                    if (_type) $scope.favouriteList[_index].favourite = 1;
                    else $scope.data.workoutlist[_index].favourite = 1;
                    NotificationHandler.favToast(0);
                }
            }, function(err) {
                ErrorHandler.errorHandler(err);
            });
        } else if (_status == 1) { //action, unfavourite
            favRecFunction(_nid, 'unfavourite').then(function(response) {
                if (response.status == 200) {
                    if (_type) $scope.favouriteList[_index].favourite = 0;
                    else $scope.data.workoutlist[_index].favourite = 0;
                    NotificationHandler.favToast(1);
                }
            }, function(err) {
                ErrorHandler.errorHandler(err);
            });
        }
    }

    $scope.recommendClick = function(_workout, _index, _type) {
        var _nid = _workout.nid;
        var _status = _workout.recommend;

        if (_status == 0) { //action, recommend
            favRecFunction(_nid, 'recommend').then(function(response) {
                if (response.status == 200) {
                    if (_type) {
                        $scope.favouriteList[_index].recommend = 1;
                        $scope.favouriteList[_index].recommends++;
                    } else {
                        $scope.data.workoutlist[_index].recommend = 1;
                        $scope.data.workoutlist[_index].recommends++;
                    }
                    if (user.uid != _workout.uid) {
                        NotificationService.send(user.name, user.uid, _workout.name, _workout.uid, _nid, 3);
                    }
                }
            }, function(err) {
                ErrorHandler.errorHandler(err);
            });
        } else if (_status == 1) { //action, unrecommend
            favRecFunction(_nid, 'unrecommend').then(function(response) {
                if (response.status == 200) {
                    if (_type) {
                        $scope.favouriteList[_index].recommend = 0;
                        if ($scope.favouriteList[_index].recommends != 0) $scope.favouriteList[_index].recommends--;
                        else $scope.favouriteList[_index].recommends = 0;
                    } else {
                        $scope.data.workoutlist[_index].recommend = 0;
                        if ($scope.data.workoutlist[_index].recommends != 0) $scope.data.workoutlist[_index].recommends--;
                        else $scope.data.workoutlist[_index].recommends = 0;
                    }
                }
            }, function(err) {
                ErrorHandler.errorHandler(err);
            });
        }
    }

    var navTo = function(_uid) {
        if (_uid) {
            if (_uid == userId) {
                $state.go('tabs.myprofile')
            } else {
                $localStorage.fromfeed = "tabs.myprofile";
                $state.go('visitorprofile', {
                    target: _uid
                });
            }
        }
    };

    $scope.navToProfile = function(_uid, _type) {
        $scope.workoutmodal.remove();
        if (!_type) {
            navTo(_uid);
        } else if (_type === 1) {
            $scope.modal_1.remove().then(function() {
                navTo(_uid);
            });
        } else if (_type === 2) {
            $scope.modal_2.remove().then(function() {
                navTo(_uid);
            });
        }

    };

    $scope.rowClass = function(exercise_index, set_index, subset_length) {
        return workoutStyle.rowClass(exercise_index, set_index, subset_length);
    };

    $scope.headClass = function(exercise_index) {
        return workoutStyle.headClass(exercise_index);
    };
    $scope.rowClassFirst = function(exercise_index, set_index, subset_length) {
        return workoutStyle.rowClassFirst(exercise_index, set_index, subset_length);
    };

    $scope.widthFn = function(display_type, position) {
        return workoutStyle.widthFn(display_type, position);
    };

    $scope.tableStyle = function(_index, _length) {
        return workoutStyle.tableStyle(_index, _length);
    };

    $scope.openFullImageModal = function() {
        $ionicModal.fromTemplateUrl('templates/full_image_modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.fullImageModal = modal;
            $scope.fullImage = $scope.user.picturePath;
            if (window.StatusBar) {
                StatusBar.hide();
            }
            $scope.fullImageModal.show();
        });
    }

    $scope.closeFullImageModal = function() {
        $scope.fullImageModal.remove();
        if (window.StatusBar) {
            StatusBar.show();
        }
    }
});