'use strict'

var app = angular.module('controllers.social', ['ionic']);
app.controller('VistorProfileCtrl', function($scope, $http, serviceComment, $ionicLoading, NotificationHandler, NotificationService, $state, workoutStyle, $localStorage, $ionicModal, ErrorHandler, $ionicHistory, $cordovaProgress, Constants, $cordovaActionSheet, $stateParams, serviceUser, UserDataService, $cordovaToast, $ionicSlideBoxDelegate) {
    var _uid = $stateParams['target'];
    var serviceUrl = Constants.API.serviceUrl;
    var IMG_PATH = Constants.API.IMG_PATH;
    var CONSTANT_TIMEOUT = Constants.timeout;
    var user = $localStorage.loginuser;
    var userId = user.uid;
    $scope.userId = user.uid;
    $scope.user = {};
    $scope.weightUnit = user.weightUnit;
    $scope.distanceUnit = user.distanceUnit;

    $scope.navBackTo = function() {
        $ionicHistory.goBack();
    }

    //privacy issue
    if (user.privacy == 2) {
        if ($ionicHistory.backView()) {
            $ionicHistory.goBack();
        } else {
            $state.go('tabs.myprofile');
        }
    } else {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner>',
            duration: CONSTANT_TIMEOUT
        });
        serviceUser.get({
            id: _uid
        }).$promise.then(function(data) {
            $ionicLoading.hide();
            if (data.visiable == 2) {
                $scope.visiable = 2;
            } else if (data.visiable == 1) {
                $scope.visiable = 1;
                if (data.picturePath) {
                    data.picturePath = IMG_PATH + data.picturePath;
                } else {
                    data.picturePath = "img/noprofile2_pic.png";
                }
                $scope.user = data;
            } else {
                $scope.visiable = 0;
                $scope.user = UserDataService.displayUser(data);
            }
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    $scope.galleryImages = [];
    $scope.noMoreImageAvailable = true;
    $scope.FullIMG = Constants.API.IMG_PATH;
    $scope.Thumbnail = Constants.API.Thumbnail;
    var galleryIndex = 0;

    var loadImage = function(_index, _uid, _flag) {
        $http.post(serviceUrl + "/user/" + _uid + "/gallery/" + _index, {}, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            if (response.data.length != 0) {
                if (response.data.length < 8) $scope.noMoreImageAvailable = true;
                else {
                    $scope.noMoreImageAvailable = false;
                    galleryIndex++;
                }
                if (_flag) {
                    $scope.galleryImages = $scope.galleryImages.concat(response.data);
                } else {
                    $scope.galleryImages = response.data;
                }
            } else {
                $scope.noMoreImageAvailable = true;
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    };


    $ionicModal.fromTemplateUrl('templates/gallery_modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.gallerymodal = modal;
    });

    $scope.navigateToGallery = function() {
        /*$ionicModal.fromTemplateUrl('templates/gallery_modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.gallerymodal = modal;
         loadImage(galleryIndex, _uid, false);
            $scope.gallerymodal.show();
        });*/

        loadImage(galleryIndex, _uid, false);
        $scope.gallerymodal.show();
    };

    $scope.loadMoreImages = function() {
        loadImage(galleryIndex, _uid, true);
    }

    $scope.naviBackTo = function() {
        $scope.gallerymodal.hide();
    };


    $ionicModal.fromTemplateUrl('templates/gallery_image_modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.imagemodal = modal;
    });

    $scope.openImageModal = function(_index) {
        if (window.StatusBar) {
            // org.apache.cordova.statusbar required
            StatusBar.hide();
        }
        $ionicSlideBoxDelegate.slide(_index);
        $scope.imagemodal.show();
    };

    $scope.closeImageModal = function() {
        $scope.imagemodal.hide();
        if (window.StatusBar) {
            StatusBar.show();
        }
    };

    $scope.slideChanged = function(index) {
        $scope.slideIndex = index;
    };


    $scope.$on('$destroy', function() {
        $scope.imagemodal.remove();
        $scope.gallerymodal.remove();
    });


    $scope.followings = function(_uid) {
        //$ionicHistory.clearCache();
        $state.go('following', {
            uid: _uid
        }, {
            reload: true
        });
    }

    $scope.followers = function(_uid) {
        //$ionicHistory.clearCache();
        $state.go('followers', {
            uid: _uid
        }, {
            reload: true
        });
    }

    $scope.following = function(_tid) {
        follow(_tid);
        /*
        var options = {
            //addDestructiveButtonWithLabel: 'Block',
            buttonLabels: ['Follow'],
            addCancelButtonWithLabel: 'Cancel',
            androidEnableCancelButton: true,
            winphoneEnableCancelButton: true
        };

        $cordovaActionSheet.show(options).then(function(btnIndex) {
            if (btnIndex == 1) follow(_tid);
            //if (btnIndex == 2) block(_tid);
        });*/
    }

    var follow = function(_tid) {
        if ($scope.visiable == 2) {
            ErrorHandler.alertPopup('Secret user could not be followed');
        } else {
            $http.post(serviceUrl + "/user/" + userId + "/follow/" + _tid, {}, {
                timeout: CONSTANT_TIMEOUT
            }).then(function(response) {
                if (response.data) {
                    $ionicHistory.clearCache();
                    if ($scope.visiable == 1) {
                        $scope.user.follow = 1;
                        NotificationService.send(user.name, user.uid, $scope.user.name, $scope.user.uid, "follow request", 2);
                    } else {
                        $scope.user.follow = true;
                        NotificationService.send(user.name, user.uid, $scope.user.name, $scope.user.uid, "follow", 1);
                    }
                }
            }, function(err) {
                if (err.status == 406) $cordovaToast.showShortCenter(err.statusText);
                else ErrorHandler.errorHandler(err);
            });
        }
    }

    $scope.unfollowing = function(_tid) {
        unfollow(_tid);
        /*
        var options = {
            buttonLabels: ['Unfollow'],
            //addDestructiveButtonWithLabel: 'Block',
            addCancelButtonWithLabel: 'Cancel',
            androidEnableCancelButton: true,
            winphoneEnableCancelButton: true
        };
        $cordovaActionSheet.show(options).then(function(btnIndex) {
            if (btnIndex == 1) unfollow(_tid);
            //if (btnIndex == 2) block(_tid);
        });*/
    }

    var unfollow = function(_tid) {
        $http.post(serviceUrl + "/user/" + userId + "/unfollow/" + _tid, {}, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            if (response.data) {
                $scope.user.follow = false;
                $ionicHistory.clearCache();
            }
        }, function(err) {
            if (err.status == 406) $cordovaToast.showLongCenter("Aleary Unfollow!");
            else ErrorHandler.errorHandler(err);
        });
    }

    $scope.report = {};
    $scope.moreOperation = function(_tid) {
        if ($scope.visiable != 2) {
            var options = {
                //addDestructiveButtonWithLabel: 'Block',
                buttonLabels: ['Block', 'Report'],
                addCancelButtonWithLabel: 'Cancel',
                androidEnableCancelButton: true,
                winphoneEnableCancelButton: true
            };
            $cordovaActionSheet.show(options).then(function(btnIndex) {
                if (btnIndex == 1) block(_tid);
                if (btnIndex == 2) report(_tid, 'user');
            });
        }

    }

    var block = function(_tid) {
        $http.post(serviceUrl + "/user/" + userId + "/block/" + _tid, {}, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            if (response.data) {
                NotificationHandler.success('Blocked');
                $ionicHistory.clearCache();
                $state.go('tabs.myprofile');
            }
        }, function(err) {
            if (err.status == 406 && err.statusText.indexOf('Invalid Operation') > -1) $cordovaToast.showShortCenter(err.statusText);
            else if (err.status == 406 && err.statusText.indexOf('Already Blocked') > -1) $cordovaToast.showShortCenter(err.statusText);
            else ErrorHandler.errorHandler(err);
        });
    };

    $scope.onHoldReport = function(_uid, _id, _type) {
        if (_uid != userId) {
            var options = {
                //addDestructiveButtonWithLabel: 'Block',
                buttonLabels: ['Report'],
                addCancelButtonWithLabel: 'Cancel',
                androidEnableCancelButton: true,
                winphoneEnableCancelButton: true
            };
            $cordovaActionSheet.show(options).then(function(btnIndex) {
                if (btnIndex == 1) report(_id, _type);
            })
        }
    }

    var report = function(_tid, _type) {
        $ionicModal.fromTemplateUrl('templates/report_modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.reportModal = modal;
            $scope.report.id = _tid;
            $scope.report.type = _type;
            $scope.reportModal.show();
        });
    };

    $scope.closeReport = function() {
        $scope.reportModal.hide();
    }

    $scope.sendReport = function() {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner>',
            duration: CONSTANT_TIMEOUT
        });
        var message = {};
        message['type'] = $scope.report.type
        message['tid'] = $scope.report.id;
        message['content'] = $scope.report.message;
        $http.post(serviceUrl + "/user/" + userId + "/report", message, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            $ionicLoading.hide();
            if (response.data) {
                NotificationHandler.success('Reported');
                $scope.reportModal.hide();
            }
        }, function(err) {
            $ionicLoading.hide();
            if (err.status == 406 && err.statusText.indexOf('You have already reported this content') > -1) $cordovaToast.showShortCenter(err.statusText);
            else ErrorHandler.errorHandler(err);
        });
    }

    $scope.openFullImageModal = function(_url) {
        $ionicModal.fromTemplateUrl('templates/full_image_modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.fullImageModal = modal;
            $scope.fullImage = _url;
            if (window.StatusBar) {
                StatusBar.hide();
            }
            $scope.fullImageModal.show();
        });
    }

    $scope.closeFullImageModal = function() {
        $scope.fullImageModal.remove();
        if (window.StatusBar) {
            StatusBar.show();
        }
    }

    var workoutIndex = 0;
    $scope.data = {};
    $scope.data.noMoreWorkoutAvailable = true;
    $scope.data.workoutlist = [];
    $scope.summaryToggle = true;
    var loadWorkout = function(_index, _userId, _flag) {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner>',
            hideOnStageChange: true,
            duration: CONSTANT_TIMEOUT
        });
        $http.post(serviceUrl + "/user/" + _userId + "/workout/" + _index, {}, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            if (response.data.length != 0) {
                if (response.data.length < 8) $scope.data.noMoreWorkoutAvailable = true;
                else {
                    $scope.data.noMoreWorkoutAvailable = false;
                    workoutIndex++;
                }
                var workouts = response.data;
                if (_flag) {
                    $scope.data.workoutlist = $scope.data.workoutlist.concat(workouts);
                } else $scope.data.workoutlist = workouts;
            } else {
                $scope.data.noMoreWorkoutAvailable = true;
            }
            $ionicLoading.hide();
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    $scope.loadMoreWorkout = function() {
        loadWorkout(workoutIndex, _uid, true);
    }

    $scope.showWorkouts = function() {
        $ionicModal.fromTemplateUrl('templates/profile_other_workout_modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.workoutmodal = modal;
            $scope.data.type = false;
            loadWorkout(workoutIndex, _uid, false);
            $scope.workoutmodal.show();
        });
    }

    $scope.closeWorkouts = function() {
        $scope.workoutmodal.remove();
    }


    $scope.showPersonalBest = function() {
        $ionicModal.fromTemplateUrl('templates/personalbests_modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.pbmodal = modal;
            $scope.pbmodal.show();
        });
    }

    $scope.closePersonalBest = function() {
        $scope.pbmodal.remove();
    }

    //Favourites
    var favouriteIndex = 0;
    $scope.data.noMoreFavouriteAvailable = true;
    $scope.favouriteList = [];
    $scope.favSummaryToggle = true;
    var loadFavourite = function(_index, _userId, _flag) {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner>',
            hideOnStageChange: true,
            duration: CONSTANT_TIMEOUT
        });
        $http.post(serviceUrl + "/user/" + _userId + "/favourite/" + _index, {}, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            if (response.data.length != 0) {
                if (response.data.length < 8) $scope.data.noMoreFavouriteAvailable = true;
                else {
                    $scope.data.noMoreFavouriteAvailable = false;
                    favouriteIndex++;
                }
                var favourites = response.data;
                if (_flag) {
                    $scope.favouriteList = $scope.favouriteList.concat(favourites);
                } else $scope.favouriteList = favourites;
            } else {
                $scope.data.noMoreFavouriteAvailable = true;
            }
            $ionicLoading.hide();
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    $scope.loadMoreFavourite = function() {
        loadFavourite(favouriteIndex, _uid, true);
    }

    $scope.showFavorites = function() {
        $ionicModal.fromTemplateUrl('templates/favourite_modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.favouritemodal = modal;
            $scope.data.type = true;
            loadFavourite(favouriteIndex, _uid, false);
            $scope.favouritemodal.show();
        });

    }

    $scope.closeFavorites = function() {
        $scope.favouritemodal.remove().then(function() {
            $scope.favouriteList = [];
            favouriteIndex = 0;
            $scope.data.noMoreFavouriteAvailable = true;
        });
    }


    $scope.data.noMoreRecommendAvailable = true;
    $scope.recommendIndex = 0;
    $scope.recommends = [];
    var loadRecommend = function(_index, _workoutId, _flag) {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner>',
            hideOnStageChange: true,
            duration: CONSTANT_TIMEOUT
        });
        $http.post(serviceUrl + "/node/" + _workoutId + "/load_recommends/" + _index, {}, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            if (response.data.length != 0) {
                if (response.data.length < 8) $scope.data.noMoreRecommendAvailable = true;
                else {
                    $scope.data.noMoreRecommendAvailable = false;
                    $scope.recommendIndex++;
                }
                var recommends = response.data;
                if (_flag) {
                    $scope.recommends = $scope.recommends.concat(recommends);
                } else $scope.recommends = recommends;
            } else {
                $scope.data.noMoreRecommendAvailable = true;
            }
            $ionicLoading.hide();
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    $scope.loadMoreRecommends = function(_nid) {
        loadRecommend($scope.recommendIndex, _nid, true);
    }

    $scope.openRecommendModal = function(_nid) {
        $ionicModal.fromTemplateUrl('modal_other_1.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_1 = modal;
            $scope.currentNID = _nid;
            loadRecommend($scope.recommendIndex, _nid, false);
            $scope.modal_1.show();
        });
    }


    //Comment
    $scope.data.shouldShowCommentDelete = false;
    $scope.data.listCommentCanSwipe = true;

    $scope.data.noMoreCommentAvailable = true;
    $scope.commentIndex = 0;
    $scope.comments = [];
    var loadComment = function(_index, _nid, _flag) {
        $ionicLoading.show({
            template: '<ion-spinner icon="ios"></ion-spinner>',
            duration: CONSTANT_TIMEOUT
        });
        serviceComment.query({
            'parameters[nid]': _nid,
            page: _index,
            pagesize: 20
        }).$promise.then(function(results) {
            if (results.length != 0) {
                if (results.length < 20) $scope.data.noMoreCommentAvailable = true;
                else {
                    $scope.data.noMoreCommentAvailable = false;
                    $scope.commentIndex++;
                }
                var comments = results;
                if (_flag) {
                    $scope.comments = $scope.comments.concat(comments);
                } else $scope.comments = comments;
            } else {
                $scope.data.noMoreCommentAvailable = true;
            }
            $ionicLoading.hide();
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }


    $scope.loadMoreComments = function(_nid) {
        loadComment($scope.commentIndex, _nid, true);
    }

    $scope.openCommentModal = function(_workout, _flag, _index) { //_flag : true open the keyboard;
        $ionicModal.fromTemplateUrl('modal_other_2.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_2 = modal;
            $scope.currentNID = _workout.nid;
            $scope.currentIndex = _index;
            $scope.currentUID = _workout.uid;
            $scope.currentUsername = _workout.name;
            loadComment($scope.commentIndex, _workout.nid, false);
            $scope.modal_2.show();
        });
    }


    $scope.deleteComment = function(_index, _type) {
        var _cid = $scope.comments[_index].cid;
        serviceComment.remove({
            id: _cid
        }).$promise.then(function(results) {
            if (results[0]) {
                $scope.comments.splice(_index, 1);
                if (_type) { //fav
                    $scope.favouriteList[$scope.currentIndex].comment_count--;
                } else {
                    $scope.data.workoutlist[$scope.currentIndex].comment_count--;
                }
            }
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    $scope.sendComment = function(_msg) {
        var _comment = {
            "nid": $scope.currentNID,
            "comment_body": {
                "und": [{
                    "value": _msg
                }]
            }
        }
        serviceComment.post(_comment).$promise.then(function(results) {
            $scope.comments = $scope.comments.concat(results);
            if ($scope.data.type) { //fav
                $scope.favouriteList[$scope.currentIndex].comment_count++;
                $scope.favouriteList[$scope.currentIndex].commented = true;
            } else {
                $scope.data.workoutlist[$scope.currentIndex].comment_count++;
                $scope.data.workoutlist[$scope.currentIndex].commented = true;
            }
            $scope.data.commentMessage = "";
            if (user.id != $scope.currentUID) {
                NotificationService.send(user.name, user.uid, $scope.currentUsername, $scope.currentUID, $scope.currentNID, 4);
            }
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    $scope.closeModal = function(_id) {
        if (_id === 1) {
            $scope.modal_1.remove().then(function() {
                $scope.recommends = [];
                $scope.data.noMoreRecommendAvailable = true;
                $scope.recommendIndex = 0;
            });
        }
        if (_id === 2) {
            $scope.modal_2.remove().then(function() {
                $scope.comments = [];
                $scope.data.noMoreCommentAvailable = true;
                $scope.commentIndex = 0;
            });

        }
    }

    var favRecFunction = function(_nid, _action) {
        return $http.post(serviceUrl + '/node/' + _nid + '/' + _action, {}, {
            timeout: CONSTANT_TIMEOUT
        })
    }

    $scope.favouriteClick = function(_nid, _status, _index, _type) {
        if (_status == 0) { //action, favourite
            favRecFunction(_nid, 'favourite').then(function(response) {
                if (response.status == 200) {
                    if (_type) $scope.favouriteList[_index].favourite = 1;
                    else $scope.data.workoutlist[_index].favourite = 1;
                    NotificationHandler.favToast(0);
                }
            }, function(err) {
                ErrorHandler.errorHandler(err);
            });
        } else if (_status == 1) { //action, unfavourite
            favRecFunction(_nid, 'unfavourite').then(function(response) {
                if (response.status == 200) {
                    if (_type) $scope.favouriteList[_index].favourite = 0;
                    else $scope.data.workoutlist[_index].favourite = 0;
                    NotificationHandler.favToast(1);
                }
            }, function(err) {
                ErrorHandler.errorHandler(err);
            });
        }
    }

    $scope.recommendClick = function(_workout, _index, _type) {
        var _nid = _workout.nid;
        var _status = _workout.recommend;

        if (_status == 0) { //action, recommend
            favRecFunction(_nid, 'recommend').then(function(response) {
                if (response.status == 200) {
                    if (_type) {
                        $scope.favouriteList[_index].recommend = 1;
                        $scope.favouriteList[_index].recommends++;
                    } else {
                        $scope.data.workoutlist[_index].recommend = 1;
                        $scope.data.workoutlist[_index].recommends++;
                    }
                    if (user.uid != _workout.uid) {
                        NotificationService.send(user.name, user.uid, _workout.name, _workout.uid, _nid, 3);
                    }
                }
            }, function(err) {
                ErrorHandler.errorHandler(err);
            });
        } else if (_status == 1) { //action, unrecommend
            favRecFunction(_nid, 'unrecommend').then(function(response) {
                if (response.status == 200) {
                    if (_type) {
                        $scope.favouriteList[_index].recommend = 0;
                        if ($scope.favouriteList[_index].recommends != 0) $scope.favouriteList[_index].recommends--;
                        else $scope.favouriteList[_index].recommends = 0;
                    } else {
                        $scope.data.workoutlist[_index].recommend = 0;
                        if ($scope.data.workoutlist[_index].recommends != 0) $scope.data.workoutlist[_index].recommends--;
                        else $scope.data.workoutlist[_index].recommends = 0;
                    }
                }
            }, function(err) {
                ErrorHandler.errorHandler(err);
            });
        }
    }

    var navTo = function(_uid) {
        if (_uid) {
            if (_uid == userId) {
                $ionicHistory.clearCache();
                $state.go('tabs.myprofile')
            } else {
                $localStorage.fromfeed = "tabs.myprofile";
                $state.go('visitorprofile', {
                    target: _uid
                });
            }
        }
    }

    $scope.navToProfile = function(_uid, _type) {
        if ($scope.workoutmodal) {
            $scope.workoutmodal.remove();
            if (!_type) {
                navTo(_uid);
            } else if (_type === 1) {
                $scope.modal_1.remove().then(function() {
                    navTo(_uid);
                });
            } else if (_type === 2) {
                $scope.modal_2.remove().then(function() {
                    navTo(_uid);
                });
            }
        }
        if ($scope.favouritemodal) {
            $scope.favouritemodal.remove();
            if (!_type) {
                navTo(_uid);
            } else if (_type === 1) {
                $scope.modal_1.remove().then(function() {
                    navTo(_uid);
                });
            } else if (_type === 2) {
                $scope.modal_2.remove().then(function() {
                    navTo(_uid);
                });
            }
        }
    };

    $scope.rowClass = function(exercise_index, set_index, subset_length) {
        return workoutStyle.rowClass(exercise_index, set_index, subset_length);
    };
    $scope.headClass = function(exercise_index, exercises_length) {
        return workoutStyle.headClassExercise(exercise_index, exercises_length);
    };

    $scope.rowClassFirst = function(exercise_index, set_index, workout_set) {
        return workoutStyle.rowClassFirst(exercise_index, set_index, workout_set);
    };

    $scope.widthFn = function(display_type, position) {
        return workoutStyle.widthFn(display_type, position);
    };

    $scope.tableStyle = function(_index, _length) {
        return workoutStyle.tableStyle(_index, _length);
    };
});

app.controller('FollowingCtrl', function($scope, $http, $location, $localStorage, ErrorHandler, $state, $cordovaProgress, $ionicHistory, Constants, $stateParams, serviceUser, UserDataService, $cordovaToast) {
    var _uid = $stateParams['uid'];
    var serviceUrl = Constants.API.serviceUrl;
    var CONSTANT_TIMEOUT = Constants.timeout;
    var user = $localStorage.loginuser;
    var userId = user.uid;
    var followingIndex = 0;



    $scope.close = function() {
        var _status = $localStorage.fromfeed;
        if (_status != null) $state.go(_status);
        else $state.go('tabs.myprofile');
    }

    $scope.navBackTo = function() {
        $ionicHistory.goBack();
    }

    $scope.followings = [];

    $scope.noMoreFollowingAvailable = true;
    var loadFollowing = function(_index, _uid, _type, _flag) {
        $http.post(serviceUrl + "/user/" + _uid + "/" + _type + "/" + _index, {}, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            if (response.data.length != 0) {
                if (response.data.length < 8) $scope.noMoreFollowingAvailable = true;
                else {
                    $scope.noMoreFollowingAvailable = false;
                    followingIndex++;
                }
                if (_flag) $scope.followings = $scope.followings.concat(response.data);
                else $scope.followings = response.data
            } else {
                $scope.noMoreFollowingAvailable = true;
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }
    loadFollowing(followingIndex, _uid, 'following', false);
    $scope.loadMoreFollowings = function() {
        loadFollowing(followingIndex, _uid, 'following', true);
    }

    $scope.navTo = function(_uid) {
        if (_uid) {
            if (_uid == userId) {
                $state.go('tabs.myprofile', {
                    reload: true
                })
            } else {
                $state.go('visitorprofile', {
                    target: _uid
                }, {
                    reload: true
                });
            }
        }
    }
});

app.controller('FollowersCtrl', function($scope, $http, $state, $location, ErrorHandler, $localStorage, $cordovaProgress, $ionicHistory, Constants, $stateParams, serviceUser, UserDataService, $cordovaToast) {
    var _uid = $stateParams['uid'];
    var _visitor_id = $localStorage.vistor_id;
    var serviceUrl = Constants.API.serviceUrl;
    var CONSTANT_TIMEOUT = Constants.timeout;
    var user = $localStorage.loginuser;
    var userId = user.uid;
    var followerIndex = 0;

    $scope.close = function() {
        var _status = $localStorage.fromfeed;
        if (_status != null) $state.go(_status);
        else $state.go('tabs.myprofile');
    }

    $scope.navBackTo = function() {
        $ionicHistory.goBack();
    }

    $scope.followers = [];
    $scope.noMoreFollowerAvailable = true;

    var loadFollower = function(_index, _uid, _type, _flag) {
        $http.post(serviceUrl + "/user/" + _uid + "/" + _type + "/" + _index, {}, {
            timeout: CONSTANT_TIMEOUT
        }).then(function(response) {
            if (response.data.length != 0) {
                if (response.data.length < 8) $scope.noMoreFollowerAvailable = true;
                else {
                    $scope.noMoreFollowerAvailable = false;
                    followerIndex++;
                }
                if (_flag) $scope.followers = $scope.followers.concat(response.data);
                else $scope.followers = response.data;
            } else {
                $scope.noMoreFollowerAvailable = true;
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function(err) {
            ErrorHandler.errorHandler(err);
        });
    }

    loadFollower(followerIndex, _uid, 'follower', false);

    $scope.loadMoreFollowers = function() {
        loadFollower(followerIndex, _uid, 'follower', true);
    }

    $scope.navTo = function(_uid) {
        if (_uid) {
            if (_uid == userId) {
                $state.go('tabs.myprofile')
            } else {
                $state.go('visitorprofile', {
                    target: _uid
                });
            }
        }
    }
});