/**
 * Filters of Time
 * @return {[type]} [description]
 * @author Chaohai Ding
 */

angular.module('filters.timeFilter', ['ionic']).filter('timeFilter', function() {
    var padding = function(value, length) {
        var zeroes = length - ('' + (value)).length,
            pad = '';
        while (zeroes-- > 0) pad += '0';
        return pad + value;
    };
    return function(value, format) {
        if (value == "-1" || value == 0) return "-";
        else {
            var totalSeconds = value,
                hh = Math.floor(totalSeconds / 3600),
                mm = Math.floor((totalSeconds % 3600) / 60),
                ss = totalSeconds % 60;

            if (hh == 0) {
                format = format || 'mm:ss';
                isPadded = true;
                mm = padding(mm, 2);
                ss = padding(ss, 2);

                return format.replace(/mm/, mm).replace(/ss/, ss);
            } else {
                format = format || 'hh:mm:ss';
                isPadded = true;
                hh = padding(hh, 2);
                mm = padding(mm, 2);
                ss = padding(ss, 2);

                return format.replace(/hh/, hh).replace(/mm/, mm).replace(/ss/, ss);
            }

        }

    };
}).filter('range', function() {
  return function(input, min, max) {
    min = parseInt(min); //Make string input int
    max = parseInt(max);
    for (var i=min; i<max; i++)
      input.push(i);
    return input;
  };
});