'use strict';

angular.module('services.common.resource', ['ionic', 'ngStorage']).factory("serviceComment", function($resource, Constants) {
    return $resource(Constants.API.serviceUrl + "/comment/:id", {}, {
        cache: true,
        timeout:Constants.timeout,
        'post': {
            method: 'POST'
        },
        'remove': {
            method: 'DELETE',
            isArray: true
        }
    });
}).factory("serviceWorkoutPost", function($resource, Constants) {
    return $resource(Constants.API.serviceUrl + "/node/:id", {}, {
        cache: true,
        timeout:Constants.timeout,
        'remove': {
            method: 'DELETE',
            isArray: true
        }
    });
}).factory("serviceUser", function($resource, Constants) {
    return $resource(Constants.API.serviceUrl + "/user/:id", {}, {
        cache: true,
        timeout:Constants.timeout,
        'update': {
            method: 'PUT'
        }
    });
}).factory("serviceFile", function($resource, Constants) {
    return $resource(Constants.API.serviceUrl + "/file/:id", {}, {
        cache: true,
        timeout:Constants.timeout
    });
}).factory("serviceWorkout", function($resource, Constants) {
    return $resource(Constants.API.serviceUrl + "/workoutpost/:id", {}, {
        cache: true,
        timeout:Constants.timeout
    });
}).factory("serviceTeam", function($resource, Constants) {
    return $resource(Constants.API.serviceUrl + "/node/:id", {}, {
        cache: true,
        timeout:Constants.timeout,
        'update': {
            method: 'PUT'
        }
    });
});